/* valaerrordomainregisterfunction.c generated by valac, the Vala compiler
 * generated from valaerrordomainregisterfunction.vala, do not modify */

/* valaerrordomainregisterfunction.vala
 *
 * Copyright (C) 2018  Rico Tzschichholz
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Rico Tzschichholz <ricotz@ubuntu.com>
 */

#include "valacodegen.h"
#include <glib.h>
#include <vala.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

static gpointer vala_error_domain_register_function_parent_class = NULL;

static GType vala_error_domain_register_function_get_type_once (void);

ValaErrorDomain*
vala_error_domain_register_function_get_error_domain_reference (ValaErrorDomainRegisterFunction* self)
{
	ValaErrorDomain* result;
	ValaTypeSymbol* _tmp0_;
	ValaTypeSymbol* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = vala_typeregister_function_get_type_symbol ((ValaTypeRegisterFunction*) self);
	_tmp1_ = _tmp0_;
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, VALA_TYPE_ERROR_DOMAIN, ValaErrorDomain);
	return result;
}

/**
 * Creates a new C function to register the specified error domain at runtime.
 *
 * @param edomain an error domain
 * @return        newly created error domain register function
 */
ValaErrorDomainRegisterFunction*
vala_error_domain_register_function_construct (GType object_type,
                                               ValaErrorDomain* edomain)
{
	ValaErrorDomainRegisterFunction* self = NULL;
	g_return_val_if_fail (edomain != NULL, NULL);
	self = (ValaErrorDomainRegisterFunction*) vala_typeregister_function_construct (object_type, (ValaTypeSymbol*) edomain);
	return self;
}

ValaErrorDomainRegisterFunction*
vala_error_domain_register_function_new (ValaErrorDomain* edomain)
{
	return vala_error_domain_register_function_construct (VALA_TYPE_ERROR_DOMAIN_REGISTER_FUNCTION, edomain);
}

static void
vala_error_domain_register_function_class_init (ValaErrorDomainRegisterFunctionClass * klass,
                                                gpointer klass_data)
{
	vala_error_domain_register_function_parent_class = g_type_class_peek_parent (klass);
}

static void
vala_error_domain_register_function_instance_init (ValaErrorDomainRegisterFunction * self,
                                                   gpointer klass)
{
}

/**
 * C function to register an error domain at runtime.
 */
static GType
vala_error_domain_register_function_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ValaErrorDomainRegisterFunctionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_error_domain_register_function_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaErrorDomainRegisterFunction), 0, (GInstanceInitFunc) vala_error_domain_register_function_instance_init, NULL };
	GType vala_error_domain_register_function_type_id;
	vala_error_domain_register_function_type_id = g_type_register_static (VALA_TYPE_TYPEREGISTER_FUNCTION, "ValaErrorDomainRegisterFunction", &g_define_type_info, 0);
	return vala_error_domain_register_function_type_id;
}

GType
vala_error_domain_register_function_get_type (void)
{
	static volatile gsize vala_error_domain_register_function_type_id__once = 0;
	if (g_once_init_enter (&vala_error_domain_register_function_type_id__once)) {
		GType vala_error_domain_register_function_type_id;
		vala_error_domain_register_function_type_id = vala_error_domain_register_function_get_type_once ();
		g_once_init_leave (&vala_error_domain_register_function_type_id__once, vala_error_domain_register_function_type_id);
	}
	return vala_error_domain_register_function_type_id__once;
}

