/* valafield.c generated by valac, the Vala compiler
 * generated from valafield.vala, do not modify */

/* valafield.vala
 *
 * Copyright (C) 2006-2010  Jürg Billeter
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 */

#include "vala.h"
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))
#define _vala_source_file_unref0(var) ((var == NULL) ? NULL : (var = (vala_source_file_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _ValaFieldPrivate {
	ValaMemberBinding _binding;
	gboolean _is_volatile;
	gboolean _lock_used;
};

static gint ValaField_private_offset;
static gpointer vala_field_parent_class = NULL;
static ValaLockableIface * vala_field_vala_lockable_parent_iface = NULL;

static void vala_field_real_accept (ValaCodeNode* base,
                             ValaCodeVisitor* visitor);
static void vala_field_real_accept_children (ValaCodeNode* base,
                                      ValaCodeVisitor* visitor);
static void vala_field_real_replace_expression (ValaCodeNode* base,
                                         ValaExpression* old_node,
                                         ValaExpression* new_node);
static void vala_field_real_replace_type (ValaCodeNode* base,
                                   ValaDataType* old_type,
                                   ValaDataType* new_type);
static gboolean vala_field_real_check (ValaCodeNode* base,
                                ValaCodeContext* context);
static void vala_field_finalize (ValaCodeNode * obj);
static GType vala_field_get_type_once (void);

static inline gpointer
vala_field_get_instance_private (ValaField* self)
{
	return G_STRUCT_MEMBER_P (self, ValaField_private_offset);
}

ValaMemberBinding
vala_field_get_binding (ValaField* self)
{
	ValaMemberBinding result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_binding;
	return result;
}

void
vala_field_set_binding (ValaField* self,
                        ValaMemberBinding value)
{
	g_return_if_fail (self != NULL);
	self->priv->_binding = value;
}

gboolean
vala_field_get_is_volatile (ValaField* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_is_volatile;
	return result;
}

void
vala_field_set_is_volatile (ValaField* self,
                            gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_is_volatile = value;
}

static gboolean
vala_field_real_get_lock_used (ValaLockable* base)
{
	gboolean result;
	ValaField* self;
	self = (ValaField*) base;
	result = self->priv->_lock_used;
	return result;
}

static void
vala_field_real_set_lock_used (ValaLockable* base,
                               gboolean value)
{
	ValaField* self;
	self = (ValaField*) base;
	self->priv->_lock_used = value;
}

/**
 * Creates a new field.
 *
 * @param name              field name
 * @param variable_type     field type
 * @param initializer       initializer expression
 * @param source_reference  reference to source code
 * @return                  newly created field
 */
ValaField*
vala_field_construct (GType object_type,
                      const gchar* name,
                      ValaDataType* variable_type,
                      ValaExpression* initializer,
                      ValaSourceReference* source_reference,
                      ValaComment* comment)
{
	ValaField* self = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (variable_type != NULL, NULL);
	self = (ValaField*) vala_variable_construct (object_type, variable_type, name, initializer, source_reference, comment);
	return self;
}

ValaField*
vala_field_new (const gchar* name,
                ValaDataType* variable_type,
                ValaExpression* initializer,
                ValaSourceReference* source_reference,
                ValaComment* comment)
{
	return vala_field_construct (VALA_TYPE_FIELD, name, variable_type, initializer, source_reference, comment);
}

static void
vala_field_real_accept (ValaCodeNode* base,
                        ValaCodeVisitor* visitor)
{
	ValaField * self;
	self = (ValaField*) base;
	g_return_if_fail (visitor != NULL);
	vala_code_visitor_visit_field (visitor, self);
}

static void
vala_field_real_accept_children (ValaCodeNode* base,
                                 ValaCodeVisitor* visitor)
{
	ValaField * self;
	ValaDataType* _tmp0_;
	ValaDataType* _tmp1_;
	ValaExpression* _tmp2_;
	ValaExpression* _tmp3_;
	self = (ValaField*) base;
	g_return_if_fail (visitor != NULL);
	_tmp0_ = vala_variable_get_variable_type ((ValaVariable*) self);
	_tmp1_ = _tmp0_;
	vala_code_node_accept ((ValaCodeNode*) _tmp1_, visitor);
	_tmp2_ = vala_variable_get_initializer ((ValaVariable*) self);
	_tmp3_ = _tmp2_;
	if (_tmp3_ != NULL) {
		ValaExpression* _tmp4_;
		ValaExpression* _tmp5_;
		_tmp4_ = vala_variable_get_initializer ((ValaVariable*) self);
		_tmp5_ = _tmp4_;
		vala_code_node_accept ((ValaCodeNode*) _tmp5_, visitor);
	}
}

static void
vala_field_real_replace_expression (ValaCodeNode* base,
                                    ValaExpression* old_node,
                                    ValaExpression* new_node)
{
	ValaField * self;
	ValaExpression* _tmp0_;
	ValaExpression* _tmp1_;
	self = (ValaField*) base;
	g_return_if_fail (old_node != NULL);
	g_return_if_fail (new_node != NULL);
	_tmp0_ = vala_variable_get_initializer ((ValaVariable*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == old_node) {
		vala_variable_set_initializer ((ValaVariable*) self, new_node);
	}
}

static void
vala_field_real_replace_type (ValaCodeNode* base,
                              ValaDataType* old_type,
                              ValaDataType* new_type)
{
	ValaField * self;
	ValaDataType* _tmp0_;
	ValaDataType* _tmp1_;
	self = (ValaField*) base;
	g_return_if_fail (old_type != NULL);
	g_return_if_fail (new_type != NULL);
	_tmp0_ = vala_variable_get_variable_type ((ValaVariable*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == old_type) {
		vala_variable_set_variable_type ((ValaVariable*) self, new_type);
	}
}

static gpointer
_vala_source_file_ref0 (gpointer self)
{
	return self ? vala_source_file_ref (self) : NULL;
}

static gpointer
_vala_code_node_ref0 (gpointer self)
{
	return self ? vala_code_node_ref (self) : NULL;
}

static gboolean
vala_field_real_check (ValaCodeNode* base,
                       ValaCodeContext* context)
{
	ValaField * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	ValaSourceFile* old_source_file = NULL;
	ValaSemanticAnalyzer* _tmp4_;
	ValaSemanticAnalyzer* _tmp5_;
	ValaSourceFile* _tmp6_;
	ValaSourceFile* _tmp7_;
	ValaSourceFile* _tmp8_;
	ValaSymbol* old_symbol = NULL;
	ValaSemanticAnalyzer* _tmp9_;
	ValaSemanticAnalyzer* _tmp10_;
	ValaSymbol* _tmp11_;
	ValaSymbol* _tmp12_;
	ValaSymbol* _tmp13_;
	ValaSourceReference* _tmp14_;
	ValaSourceReference* _tmp15_;
	ValaSemanticAnalyzer* _tmp22_;
	ValaSemanticAnalyzer* _tmp23_;
	ValaDataType* _tmp24_;
	ValaDataType* _tmp25_;
	ValaDataType* _tmp28_;
	ValaDataType* _tmp29_;
	ValaTypeSymbol* _tmp30_;
	ValaTypeSymbol* _tmp31_;
	ValaSemanticAnalyzer* _tmp32_;
	ValaSemanticAnalyzer* _tmp33_;
	ValaDataType* _tmp34_;
	ValaTypeSymbol* _tmp35_;
	ValaTypeSymbol* _tmp36_;
	gboolean _tmp45_ = FALSE;
	ValaDataType* _tmp54_;
	ValaDataType* _tmp55_;
	gboolean _tmp56_;
	gboolean _tmp57_;
	ValaDataType* _tmp76_;
	ValaDataType* _tmp77_;
	ValaArrayType* variable_array_type = NULL;
	ValaDataType* _tmp86_;
	ValaDataType* _tmp87_;
	gboolean _tmp88_ = FALSE;
	gboolean _tmp89_ = FALSE;
	gboolean _tmp90_ = FALSE;
	ValaArrayType* _tmp91_;
	gboolean _tmp103_ = FALSE;
	gboolean _tmp104_ = FALSE;
	ValaArrayType* _tmp105_;
	ValaExpression* _tmp114_;
	ValaExpression* _tmp115_;
	gboolean _tmp238_ = FALSE;
	ValaMemberBinding _tmp239_;
	gboolean field_in_header = FALSE;
	ValaSymbol* _tmp244_;
	ValaSymbol* _tmp245_;
	gboolean _tmp254_ = FALSE;
	gboolean _tmp255_ = FALSE;
	gboolean _tmp256_;
	gboolean _tmp257_;
	ValaSemanticAnalyzer* _tmp270_;
	ValaSemanticAnalyzer* _tmp271_;
	ValaSourceFile* _tmp272_;
	ValaSemanticAnalyzer* _tmp273_;
	ValaSemanticAnalyzer* _tmp274_;
	ValaSymbol* _tmp275_;
	gboolean _tmp276_;
	gboolean _tmp277_;
	gboolean result;
	self = (ValaField*) base;
	g_return_val_if_fail (context != NULL, FALSE);
	_tmp0_ = vala_code_node_get_checked ((ValaCodeNode*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		gboolean _tmp2_;
		gboolean _tmp3_;
		_tmp2_ = vala_code_node_get_error ((ValaCodeNode*) self);
		_tmp3_ = _tmp2_;
		result = !_tmp3_;
		return result;
	}
	vala_code_node_set_checked ((ValaCodeNode*) self, TRUE);
	_tmp4_ = vala_code_context_get_analyzer (context);
	_tmp5_ = _tmp4_;
	_tmp6_ = vala_semantic_analyzer_get_current_source_file (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = _vala_source_file_ref0 (_tmp7_);
	old_source_file = _tmp8_;
	_tmp9_ = vala_code_context_get_analyzer (context);
	_tmp10_ = _tmp9_;
	_tmp11_ = vala_semantic_analyzer_get_current_symbol (_tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = _vala_code_node_ref0 (_tmp12_);
	old_symbol = _tmp13_;
	_tmp14_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
	_tmp15_ = _tmp14_;
	if (_tmp15_ != NULL) {
		ValaSemanticAnalyzer* _tmp16_;
		ValaSemanticAnalyzer* _tmp17_;
		ValaSourceReference* _tmp18_;
		ValaSourceReference* _tmp19_;
		ValaSourceFile* _tmp20_;
		ValaSourceFile* _tmp21_;
		_tmp16_ = vala_code_context_get_analyzer (context);
		_tmp17_ = _tmp16_;
		_tmp18_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp19_ = _tmp18_;
		_tmp20_ = vala_source_reference_get_file (_tmp19_);
		_tmp21_ = _tmp20_;
		vala_semantic_analyzer_set_current_source_file (_tmp17_, _tmp21_);
	}
	_tmp22_ = vala_code_context_get_analyzer (context);
	_tmp23_ = _tmp22_;
	vala_semantic_analyzer_set_current_symbol (_tmp23_, (ValaSymbol*) self);
	_tmp24_ = vala_variable_get_variable_type ((ValaVariable*) self);
	_tmp25_ = _tmp24_;
	if (VALA_IS_VOID_TYPE (_tmp25_)) {
		ValaSourceReference* _tmp26_;
		ValaSourceReference* _tmp27_;
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		_tmp26_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp27_ = _tmp26_;
		vala_report_error (_tmp27_, "'void' not supported as field type");
		result = FALSE;
		_vala_code_node_unref0 (old_symbol);
		_vala_source_file_unref0 (old_source_file);
		return result;
	}
	_tmp28_ = vala_variable_get_variable_type ((ValaVariable*) self);
	_tmp29_ = _tmp28_;
	_tmp30_ = vala_data_type_get_type_symbol (_tmp29_);
	_tmp31_ = _tmp30_;
	_tmp32_ = vala_code_context_get_analyzer (context);
	_tmp33_ = _tmp32_;
	_tmp34_ = _tmp33_->va_list_type;
	_tmp35_ = vala_data_type_get_type_symbol (_tmp34_);
	_tmp36_ = _tmp35_;
	if (_tmp31_ == _tmp36_) {
		ValaSourceReference* _tmp37_;
		ValaSourceReference* _tmp38_;
		ValaDataType* _tmp39_;
		ValaDataType* _tmp40_;
		ValaTypeSymbol* _tmp41_;
		ValaTypeSymbol* _tmp42_;
		gchar* _tmp43_;
		gchar* _tmp44_;
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		_tmp37_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp38_ = _tmp37_;
		_tmp39_ = vala_variable_get_variable_type ((ValaVariable*) self);
		_tmp40_ = _tmp39_;
		_tmp41_ = vala_data_type_get_type_symbol (_tmp40_);
		_tmp42_ = _tmp41_;
		_tmp43_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp42_);
		_tmp44_ = _tmp43_;
		vala_report_error (_tmp38_, "`%s' not supported as field type", _tmp44_);
		_g_free0 (_tmp44_);
		result = FALSE;
		_vala_code_node_unref0 (old_symbol);
		_vala_source_file_unref0 (old_source_file);
		return result;
	}
	if (vala_code_node_has_attribute ((ValaCodeNode*) self, "GtkChild")) {
		ValaDataType* _tmp46_;
		ValaDataType* _tmp47_;
		gboolean _tmp48_;
		gboolean _tmp49_;
		_tmp46_ = vala_variable_get_variable_type ((ValaVariable*) self);
		_tmp47_ = _tmp46_;
		_tmp48_ = vala_data_type_get_value_owned (_tmp47_);
		_tmp49_ = _tmp48_;
		_tmp45_ = _tmp49_;
	} else {
		_tmp45_ = FALSE;
	}
	if (_tmp45_) {
		ValaSourceReference* _tmp50_;
		ValaSourceReference* _tmp51_;
		ValaDataType* _tmp52_;
		ValaDataType* _tmp53_;
		_tmp50_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp51_ = _tmp50_;
		vala_report_warning (_tmp51_, "[GtkChild] fields must be declared as `unowned'");
		_tmp52_ = vala_variable_get_variable_type ((ValaVariable*) self);
		_tmp53_ = _tmp52_;
		vala_data_type_set_value_owned (_tmp53_, FALSE);
	}
	_tmp54_ = vala_variable_get_variable_type ((ValaVariable*) self);
	_tmp55_ = _tmp54_;
	vala_code_node_check ((ValaCodeNode*) _tmp55_, context);
	_tmp56_ = vala_symbol_get_external_package ((ValaSymbol*) self);
	_tmp57_ = _tmp56_;
	if (!_tmp57_) {
		ValaSemanticAnalyzer* _tmp58_;
		ValaSemanticAnalyzer* _tmp59_;
		ValaDataType* _tmp60_;
		ValaDataType* _tmp61_;
		ValaDataType* _tmp62_;
		ValaDataType* _tmp63_;
		ValaDataType* _tmp64_;
		ValaDataType* _tmp65_;
		ValaTypeSymbol* _tmp66_;
		ValaTypeSymbol* _tmp67_;
		_tmp58_ = vala_code_context_get_analyzer (context);
		_tmp59_ = _tmp58_;
		_tmp60_ = vala_variable_get_variable_type ((ValaVariable*) self);
		_tmp61_ = _tmp60_;
		vala_semantic_analyzer_check_type (_tmp59_, _tmp61_);
		_tmp62_ = vala_variable_get_variable_type ((ValaVariable*) self);
		_tmp63_ = _tmp62_;
		vala_data_type_check_type_arguments (_tmp63_, context, TRUE);
		_tmp64_ = vala_variable_get_variable_type ((ValaVariable*) self);
		_tmp65_ = _tmp64_;
		_tmp66_ = vala_data_type_get_type_symbol (_tmp65_);
		_tmp67_ = _tmp66_;
		if (_tmp67_ != NULL) {
			ValaDataType* _tmp68_;
			ValaDataType* _tmp69_;
			ValaTypeSymbol* _tmp70_;
			ValaTypeSymbol* _tmp71_;
			ValaVersionAttribute* _tmp72_;
			ValaVersionAttribute* _tmp73_;
			ValaSourceReference* _tmp74_;
			ValaSourceReference* _tmp75_;
			_tmp68_ = vala_variable_get_variable_type ((ValaVariable*) self);
			_tmp69_ = _tmp68_;
			_tmp70_ = vala_data_type_get_type_symbol (_tmp69_);
			_tmp71_ = _tmp70_;
			_tmp72_ = vala_symbol_get_version ((ValaSymbol*) _tmp71_);
			_tmp73_ = _tmp72_;
			_tmp74_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp75_ = _tmp74_;
			vala_version_attribute_check (_tmp73_, context, _tmp75_);
		}
	}
	_tmp76_ = vala_variable_get_variable_type ((ValaVariable*) self);
	_tmp77_ = _tmp76_;
	if (!vala_data_type_is_accessible (_tmp77_, (ValaSymbol*) self)) {
		ValaSourceReference* _tmp78_;
		ValaSourceReference* _tmp79_;
		ValaDataType* _tmp80_;
		ValaDataType* _tmp81_;
		gchar* _tmp82_;
		gchar* _tmp83_;
		gchar* _tmp84_;
		gchar* _tmp85_;
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		_tmp78_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp79_ = _tmp78_;
		_tmp80_ = vala_variable_get_variable_type ((ValaVariable*) self);
		_tmp81_ = _tmp80_;
		_tmp82_ = vala_code_node_to_string ((ValaCodeNode*) _tmp81_);
		_tmp83_ = _tmp82_;
		_tmp84_ = vala_symbol_get_full_name ((ValaSymbol*) self);
		_tmp85_ = _tmp84_;
		vala_report_error (_tmp79_, "field type `%s' is less accessible than field `%s'", _tmp83_, _tmp85_);
		_g_free0 (_tmp85_);
		_g_free0 (_tmp83_);
		result = FALSE;
		_vala_code_node_unref0 (old_symbol);
		_vala_source_file_unref0 (old_source_file);
		return result;
	}
	_tmp86_ = vala_variable_get_variable_type ((ValaVariable*) self);
	_tmp87_ = _tmp86_;
	variable_array_type = VALA_IS_ARRAY_TYPE (_tmp87_) ? ((ValaArrayType*) _tmp87_) : NULL;
	_tmp91_ = variable_array_type;
	if (_tmp91_ != NULL) {
		ValaArrayType* _tmp92_;
		gboolean _tmp93_;
		gboolean _tmp94_;
		_tmp92_ = variable_array_type;
		_tmp93_ = vala_array_type_get_inline_allocated (_tmp92_);
		_tmp94_ = _tmp93_;
		_tmp90_ = _tmp94_;
	} else {
		_tmp90_ = FALSE;
	}
	if (_tmp90_) {
		ValaExpression* _tmp95_;
		ValaExpression* _tmp96_;
		_tmp95_ = vala_variable_get_initializer ((ValaVariable*) self);
		_tmp96_ = _tmp95_;
		_tmp89_ = VALA_IS_ARRAY_CREATION_EXPRESSION (_tmp96_);
	} else {
		_tmp89_ = FALSE;
	}
	if (_tmp89_) {
		ValaExpression* _tmp97_;
		ValaExpression* _tmp98_;
		ValaInitializerList* _tmp99_;
		ValaInitializerList* _tmp100_;
		_tmp97_ = vala_variable_get_initializer ((ValaVariable*) self);
		_tmp98_ = _tmp97_;
		_tmp99_ = vala_array_creation_expression_get_initializer_list (G_TYPE_CHECK_INSTANCE_CAST (_tmp98_, VALA_TYPE_ARRAY_CREATION_EXPRESSION, ValaArrayCreationExpression));
		_tmp100_ = _tmp99_;
		_tmp88_ = _tmp100_ == NULL;
	} else {
		_tmp88_ = FALSE;
	}
	if (_tmp88_) {
		ValaSourceReference* _tmp101_;
		ValaSourceReference* _tmp102_;
		_tmp101_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp102_ = _tmp101_;
		vala_report_warning (_tmp102_, "Inline allocated arrays don't require an explicit instantiation");
		vala_variable_set_initializer ((ValaVariable*) self, NULL);
	}
	_tmp105_ = variable_array_type;
	if (_tmp105_ != NULL) {
		ValaArrayType* _tmp106_;
		gboolean _tmp107_;
		gboolean _tmp108_;
		_tmp106_ = variable_array_type;
		_tmp107_ = vala_array_type_get_inline_allocated (_tmp106_);
		_tmp108_ = _tmp107_;
		_tmp104_ = _tmp108_;
	} else {
		_tmp104_ = FALSE;
	}
	if (_tmp104_) {
		ValaArrayType* _tmp109_;
		gboolean _tmp110_;
		gboolean _tmp111_;
		_tmp109_ = variable_array_type;
		_tmp110_ = vala_array_type_get_fixed_length (_tmp109_);
		_tmp111_ = _tmp110_;
		_tmp103_ = !_tmp111_;
	} else {
		_tmp103_ = FALSE;
	}
	if (_tmp103_) {
		ValaSourceReference* _tmp112_;
		ValaSourceReference* _tmp113_;
		_tmp112_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp113_ = _tmp112_;
		vala_report_error (_tmp113_, "Inline allocated array as field requires to have fixed length");
	}
	_tmp114_ = vala_variable_get_initializer ((ValaVariable*) self);
	_tmp115_ = _tmp114_;
	if (_tmp115_ != NULL) {
		ValaExpression* _tmp116_;
		ValaExpression* _tmp117_;
		ValaDataType* _tmp118_;
		ValaDataType* _tmp119_;
		gboolean is_initializer_list = FALSE;
		gint initializer_size = 0;
		ValaExpression* _tmp120_;
		ValaExpression* _tmp121_;
		ValaExpression* _tmp126_;
		ValaExpression* _tmp127_;
		ValaExpression* _tmp128_;
		ValaExpression* _tmp129_;
		ValaDataType* _tmp130_;
		ValaDataType* _tmp131_;
		ValaExpression* _tmp136_;
		ValaExpression* _tmp137_;
		ValaDataType* _tmp138_;
		ValaDataType* _tmp139_;
		ValaDataType* _tmp140_;
		ValaDataType* _tmp141_;
		gboolean _tmp154_ = FALSE;
		gboolean _tmp155_ = FALSE;
		gboolean _tmp156_ = FALSE;
		ValaArrayType* _tmp157_;
		gboolean _tmp171_ = FALSE;
		gboolean _tmp172_ = FALSE;
		ValaArrayType* _tmp173_;
		ValaExpression* _tmp183_;
		ValaExpression* _tmp184_;
		ValaDataType* _tmp185_;
		ValaDataType* _tmp186_;
		gboolean _tmp196_ = FALSE;
		ValaSymbol* _tmp197_;
		ValaSymbol* _tmp198_;
		gboolean _tmp203_ = FALSE;
		gboolean _tmp204_ = FALSE;
		ValaSymbol* _tmp205_;
		ValaSymbol* _tmp206_;
		gboolean _tmp220_ = FALSE;
		gboolean _tmp221_ = FALSE;
		gboolean _tmp222_ = FALSE;
		ValaMemberBinding _tmp223_;
		gboolean _tmp234_;
		gboolean _tmp235_;
		_tmp116_ = vala_variable_get_initializer ((ValaVariable*) self);
		_tmp117_ = _tmp116_;
		_tmp118_ = vala_variable_get_variable_type ((ValaVariable*) self);
		_tmp119_ = _tmp118_;
		vala_expression_set_target_type (_tmp117_, _tmp119_);
		is_initializer_list = FALSE;
		initializer_size = -1;
		_tmp120_ = vala_variable_get_initializer ((ValaVariable*) self);
		_tmp121_ = _tmp120_;
		if (VALA_IS_INITIALIZER_LIST (_tmp121_)) {
			ValaExpression* _tmp122_;
			ValaExpression* _tmp123_;
			gint _tmp124_;
			gint _tmp125_;
			_tmp122_ = vala_variable_get_initializer ((ValaVariable*) self);
			_tmp123_ = _tmp122_;
			_tmp124_ = vala_initializer_list_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp123_, VALA_TYPE_INITIALIZER_LIST, ValaInitializerList));
			_tmp125_ = _tmp124_;
			initializer_size = _tmp125_;
			is_initializer_list = TRUE;
		}
		_tmp126_ = vala_variable_get_initializer ((ValaVariable*) self);
		_tmp127_ = _tmp126_;
		if (!vala_code_node_check ((ValaCodeNode*) _tmp127_, context)) {
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			result = FALSE;
			_vala_code_node_unref0 (old_symbol);
			_vala_source_file_unref0 (old_source_file);
			return result;
		}
		_tmp128_ = vala_variable_get_initializer ((ValaVariable*) self);
		_tmp129_ = _tmp128_;
		_tmp130_ = vala_expression_get_value_type (_tmp129_);
		_tmp131_ = _tmp130_;
		if (_tmp131_ == NULL) {
			ValaExpression* _tmp132_;
			ValaExpression* _tmp133_;
			ValaSourceReference* _tmp134_;
			ValaSourceReference* _tmp135_;
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			_tmp132_ = vala_variable_get_initializer ((ValaVariable*) self);
			_tmp133_ = _tmp132_;
			_tmp134_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp133_);
			_tmp135_ = _tmp134_;
			vala_report_error (_tmp135_, "expression type not allowed as initializer");
			result = FALSE;
			_vala_code_node_unref0 (old_symbol);
			_vala_source_file_unref0 (old_source_file);
			return result;
		}
		_tmp136_ = vala_variable_get_initializer ((ValaVariable*) self);
		_tmp137_ = _tmp136_;
		_tmp138_ = vala_expression_get_value_type (_tmp137_);
		_tmp139_ = _tmp138_;
		_tmp140_ = vala_variable_get_variable_type ((ValaVariable*) self);
		_tmp141_ = _tmp140_;
		if (!vala_data_type_compatible (_tmp139_, _tmp141_)) {
			ValaSourceReference* _tmp142_;
			ValaSourceReference* _tmp143_;
			ValaExpression* _tmp144_;
			ValaExpression* _tmp145_;
			ValaDataType* _tmp146_;
			ValaDataType* _tmp147_;
			gchar* _tmp148_;
			gchar* _tmp149_;
			ValaDataType* _tmp150_;
			ValaDataType* _tmp151_;
			gchar* _tmp152_;
			gchar* _tmp153_;
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			_tmp142_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp143_ = _tmp142_;
			_tmp144_ = vala_variable_get_initializer ((ValaVariable*) self);
			_tmp145_ = _tmp144_;
			_tmp146_ = vala_expression_get_value_type (_tmp145_);
			_tmp147_ = _tmp146_;
			_tmp148_ = vala_code_node_to_string ((ValaCodeNode*) _tmp147_);
			_tmp149_ = _tmp148_;
			_tmp150_ = vala_variable_get_variable_type ((ValaVariable*) self);
			_tmp151_ = _tmp150_;
			_tmp152_ = vala_code_node_to_string ((ValaCodeNode*) _tmp151_);
			_tmp153_ = _tmp152_;
			vala_report_error (_tmp143_, "Cannot convert from `%s' to `%s'", _tmp149_, _tmp153_);
			_g_free0 (_tmp153_);
			_g_free0 (_tmp149_);
			result = FALSE;
			_vala_code_node_unref0 (old_symbol);
			_vala_source_file_unref0 (old_source_file);
			return result;
		}
		_tmp157_ = variable_array_type;
		if (_tmp157_ != NULL) {
			ValaArrayType* _tmp158_;
			gboolean _tmp159_;
			gboolean _tmp160_;
			_tmp158_ = variable_array_type;
			_tmp159_ = vala_array_type_get_inline_allocated (_tmp158_);
			_tmp160_ = _tmp159_;
			_tmp156_ = _tmp160_;
		} else {
			_tmp156_ = FALSE;
		}
		if (_tmp156_) {
			ValaArrayType* _tmp161_;
			gboolean _tmp162_;
			gboolean _tmp163_;
			_tmp161_ = variable_array_type;
			_tmp162_ = vala_array_type_get_fixed_length (_tmp161_);
			_tmp163_ = _tmp162_;
			_tmp155_ = !_tmp163_;
		} else {
			_tmp155_ = FALSE;
		}
		if (_tmp155_) {
			_tmp154_ = is_initializer_list;
		} else {
			_tmp154_ = FALSE;
		}
		if (_tmp154_) {
			ValaArrayType* _tmp164_;
			gchar* _tmp165_;
			gchar* _tmp166_;
			ValaIntegerLiteral* _tmp167_;
			ValaIntegerLiteral* _tmp168_;
			ValaArrayType* _tmp169_;
			ValaArrayType* _tmp170_;
			_tmp164_ = variable_array_type;
			_tmp165_ = g_strdup_printf ("%i", initializer_size);
			_tmp166_ = _tmp165_;
			_tmp167_ = vala_integer_literal_new (_tmp166_, NULL);
			_tmp168_ = _tmp167_;
			vala_array_type_set_length (_tmp164_, (ValaExpression*) _tmp168_);
			_vala_code_node_unref0 (_tmp168_);
			_g_free0 (_tmp166_);
			_tmp169_ = variable_array_type;
			vala_array_type_set_fixed_length (_tmp169_, TRUE);
			_tmp170_ = variable_array_type;
			vala_data_type_set_nullable ((ValaDataType*) _tmp170_, FALSE);
		}
		_tmp173_ = variable_array_type;
		if (_tmp173_ != NULL) {
			ValaArrayType* _tmp174_;
			gboolean _tmp175_;
			gboolean _tmp176_;
			_tmp174_ = variable_array_type;
			_tmp175_ = vala_array_type_get_inline_allocated (_tmp174_);
			_tmp176_ = _tmp175_;
			_tmp172_ = _tmp176_;
		} else {
			_tmp172_ = FALSE;
		}
		if (_tmp172_) {
			ValaExpression* _tmp177_;
			ValaExpression* _tmp178_;
			ValaDataType* _tmp179_;
			ValaDataType* _tmp180_;
			_tmp177_ = vala_variable_get_initializer ((ValaVariable*) self);
			_tmp178_ = _tmp177_;
			_tmp179_ = vala_expression_get_value_type (_tmp178_);
			_tmp180_ = _tmp179_;
			_tmp171_ = !VALA_IS_ARRAY_TYPE (_tmp180_);
		} else {
			_tmp171_ = FALSE;
		}
		if (_tmp171_) {
			ValaSourceReference* _tmp181_;
			ValaSourceReference* _tmp182_;
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			_tmp181_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp182_ = _tmp181_;
			vala_report_error (_tmp182_, "only arrays are allowed as initializer for arrays with fixed length");
			result = FALSE;
			_vala_code_node_unref0 (old_symbol);
			_vala_source_file_unref0 (old_source_file);
			return result;
		}
		_tmp183_ = vala_variable_get_initializer ((ValaVariable*) self);
		_tmp184_ = _tmp183_;
		_tmp185_ = vala_expression_get_value_type (_tmp184_);
		_tmp186_ = _tmp185_;
		if (vala_data_type_is_disposable (_tmp186_)) {
			gboolean _tmp187_ = FALSE;
			ValaDataType* _tmp188_;
			ValaDataType* _tmp189_;
			_tmp188_ = vala_variable_get_variable_type ((ValaVariable*) self);
			_tmp189_ = _tmp188_;
			if (!VALA_IS_POINTER_TYPE (_tmp189_)) {
				ValaDataType* _tmp190_;
				ValaDataType* _tmp191_;
				gboolean _tmp192_;
				gboolean _tmp193_;
				_tmp190_ = vala_variable_get_variable_type ((ValaVariable*) self);
				_tmp191_ = _tmp190_;
				_tmp192_ = vala_data_type_get_value_owned (_tmp191_);
				_tmp193_ = _tmp192_;
				_tmp187_ = !_tmp193_;
			} else {
				_tmp187_ = FALSE;
			}
			if (_tmp187_) {
				ValaSourceReference* _tmp194_;
				ValaSourceReference* _tmp195_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp194_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp195_ = _tmp194_;
				vala_report_error (_tmp195_, "Invalid assignment from owned expression to unowned variable");
				result = FALSE;
				_vala_code_node_unref0 (old_symbol);
				_vala_source_file_unref0 (old_source_file);
				return result;
			}
		}
		_tmp197_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
		_tmp198_ = _tmp197_;
		if (VALA_IS_NAMESPACE (_tmp198_)) {
			ValaExpression* _tmp199_;
			ValaExpression* _tmp200_;
			_tmp199_ = vala_variable_get_initializer ((ValaVariable*) self);
			_tmp200_ = _tmp199_;
			_tmp196_ = !vala_expression_is_constant (_tmp200_);
		} else {
			_tmp196_ = FALSE;
		}
		if (_tmp196_) {
			ValaSourceReference* _tmp201_;
			ValaSourceReference* _tmp202_;
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			_tmp201_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp202_ = _tmp201_;
			vala_report_error (_tmp202_, "Non-constant field initializers not supported in this context");
			result = FALSE;
			_vala_code_node_unref0 (old_symbol);
			_vala_source_file_unref0 (old_source_file);
			return result;
		}
		_tmp205_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
		_tmp206_ = _tmp205_;
		if (VALA_IS_NAMESPACE (_tmp206_)) {
			ValaExpression* _tmp207_;
			ValaExpression* _tmp208_;
			_tmp207_ = vala_variable_get_initializer ((ValaVariable*) self);
			_tmp208_ = _tmp207_;
			_tmp204_ = vala_expression_is_constant (_tmp208_);
		} else {
			_tmp204_ = FALSE;
		}
		if (_tmp204_) {
			ValaExpression* _tmp209_;
			ValaExpression* _tmp210_;
			_tmp209_ = vala_variable_get_initializer ((ValaVariable*) self);
			_tmp210_ = _tmp209_;
			_tmp203_ = vala_expression_is_non_null (_tmp210_);
		} else {
			_tmp203_ = FALSE;
		}
		if (_tmp203_) {
			gboolean _tmp211_ = FALSE;
			ValaDataType* _tmp212_;
			ValaDataType* _tmp213_;
			_tmp212_ = vala_variable_get_variable_type ((ValaVariable*) self);
			_tmp213_ = _tmp212_;
			if (vala_data_type_is_disposable (_tmp213_)) {
				ValaDataType* _tmp214_;
				ValaDataType* _tmp215_;
				gboolean _tmp216_;
				gboolean _tmp217_;
				_tmp214_ = vala_variable_get_variable_type ((ValaVariable*) self);
				_tmp215_ = _tmp214_;
				_tmp216_ = vala_data_type_get_value_owned (_tmp215_);
				_tmp217_ = _tmp216_;
				_tmp211_ = _tmp217_;
			} else {
				_tmp211_ = FALSE;
			}
			if (_tmp211_) {
				ValaSourceReference* _tmp218_;
				ValaSourceReference* _tmp219_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp218_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp219_ = _tmp218_;
				vala_report_error (_tmp219_, "Owned namespace fields can only be initialized in a function or method");
				result = FALSE;
				_vala_code_node_unref0 (old_symbol);
				_vala_source_file_unref0 (old_source_file);
				return result;
			}
		}
		_tmp223_ = self->priv->_binding;
		if (_tmp223_ == VALA_MEMBER_BINDING_STATIC) {
			ValaSymbol* _tmp224_;
			ValaSymbol* _tmp225_;
			_tmp224_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
			_tmp225_ = _tmp224_;
			_tmp222_ = VALA_IS_CLASS (_tmp225_);
		} else {
			_tmp222_ = FALSE;
		}
		if (_tmp222_) {
			ValaSymbol* _tmp226_;
			ValaSymbol* _tmp227_;
			gboolean _tmp228_;
			gboolean _tmp229_;
			_tmp226_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
			_tmp227_ = _tmp226_;
			_tmp228_ = vala_class_get_is_compact (G_TYPE_CHECK_INSTANCE_CAST (_tmp227_, VALA_TYPE_CLASS, ValaClass));
			_tmp229_ = _tmp228_;
			_tmp221_ = _tmp229_;
		} else {
			_tmp221_ = FALSE;
		}
		if (_tmp221_) {
			ValaExpression* _tmp230_;
			ValaExpression* _tmp231_;
			_tmp230_ = vala_variable_get_initializer ((ValaVariable*) self);
			_tmp231_ = _tmp230_;
			_tmp220_ = !vala_expression_is_constant (_tmp231_);
		} else {
			_tmp220_ = FALSE;
		}
		if (_tmp220_) {
			ValaSourceReference* _tmp232_;
			ValaSourceReference* _tmp233_;
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			_tmp232_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp233_ = _tmp232_;
			vala_report_error (_tmp233_, "Static fields in compact classes cannot have non-constant initializers");
			result = FALSE;
			_vala_code_node_unref0 (old_symbol);
			_vala_source_file_unref0 (old_source_file);
			return result;
		}
		_tmp234_ = vala_symbol_get_external ((ValaSymbol*) self);
		_tmp235_ = _tmp234_;
		if (_tmp235_) {
			ValaSourceReference* _tmp236_;
			ValaSourceReference* _tmp237_;
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			_tmp236_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp237_ = _tmp236_;
			vala_report_error (_tmp237_, "External fields cannot use initializers");
		}
	}
	_tmp239_ = self->priv->_binding;
	if (_tmp239_ == VALA_MEMBER_BINDING_INSTANCE) {
		ValaSymbol* _tmp240_;
		ValaSymbol* _tmp241_;
		_tmp240_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
		_tmp241_ = _tmp240_;
		_tmp238_ = VALA_IS_INTERFACE (_tmp241_);
	} else {
		_tmp238_ = FALSE;
	}
	if (_tmp238_) {
		ValaSourceReference* _tmp242_;
		ValaSourceReference* _tmp243_;
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		_tmp242_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp243_ = _tmp242_;
		vala_report_error (_tmp243_, "Interfaces may not have instance fields");
		result = FALSE;
		_vala_code_node_unref0 (old_symbol);
		_vala_source_file_unref0 (old_source_file);
		return result;
	}
	field_in_header = !vala_symbol_is_internal_symbol ((ValaSymbol*) self);
	_tmp244_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
	_tmp245_ = _tmp244_;
	if (VALA_IS_CLASS (_tmp245_)) {
		ValaClass* cl = NULL;
		ValaSymbol* _tmp246_;
		ValaSymbol* _tmp247_;
		ValaClass* _tmp248_;
		gboolean _tmp249_ = FALSE;
		ValaClass* _tmp250_;
		gboolean _tmp251_;
		gboolean _tmp252_;
		_tmp246_ = vala_symbol_get_parent_symbol ((ValaSymbol*) self);
		_tmp247_ = _tmp246_;
		_tmp248_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp247_, VALA_TYPE_CLASS, ValaClass));
		cl = _tmp248_;
		_tmp250_ = cl;
		_tmp251_ = vala_class_get_is_compact (_tmp250_);
		_tmp252_ = _tmp251_;
		if (_tmp252_) {
			ValaClass* _tmp253_;
			_tmp253_ = cl;
			_tmp249_ = !vala_symbol_is_internal_symbol ((ValaSymbol*) _tmp253_);
		} else {
			_tmp249_ = FALSE;
		}
		if (_tmp249_) {
			field_in_header = TRUE;
		}
		_vala_code_node_unref0 (cl);
	}
	_tmp256_ = vala_symbol_get_external_package ((ValaSymbol*) self);
	_tmp257_ = _tmp256_;
	if (!_tmp257_) {
		gboolean _tmp258_;
		gboolean _tmp259_;
		_tmp258_ = vala_symbol_get_hides ((ValaSymbol*) self);
		_tmp259_ = _tmp258_;
		_tmp255_ = !_tmp259_;
	} else {
		_tmp255_ = FALSE;
	}
	if (_tmp255_) {
		ValaSymbol* _tmp260_;
		ValaSymbol* _tmp261_;
		_tmp260_ = vala_symbol_get_hidden_member ((ValaSymbol*) self);
		_tmp261_ = _tmp260_;
		_tmp254_ = _tmp261_ != NULL;
		_vala_code_node_unref0 (_tmp261_);
	} else {
		_tmp254_ = FALSE;
	}
	if (_tmp254_) {
		ValaSourceReference* _tmp262_;
		ValaSourceReference* _tmp263_;
		gchar* _tmp264_;
		gchar* _tmp265_;
		ValaSymbol* _tmp266_;
		ValaSymbol* _tmp267_;
		gchar* _tmp268_;
		gchar* _tmp269_;
		_tmp262_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp263_ = _tmp262_;
		_tmp264_ = vala_symbol_get_full_name ((ValaSymbol*) self);
		_tmp265_ = _tmp264_;
		_tmp266_ = vala_symbol_get_hidden_member ((ValaSymbol*) self);
		_tmp267_ = _tmp266_;
		_tmp268_ = vala_symbol_get_full_name (_tmp267_);
		_tmp269_ = _tmp268_;
		vala_report_warning (_tmp263_, "%s hides inherited field `%s'. Use the `new' keyword if hiding was int" \
"entional", _tmp265_, _tmp269_);
		_g_free0 (_tmp269_);
		_vala_code_node_unref0 (_tmp267_);
		_g_free0 (_tmp265_);
	}
	_tmp270_ = vala_code_context_get_analyzer (context);
	_tmp271_ = _tmp270_;
	_tmp272_ = old_source_file;
	vala_semantic_analyzer_set_current_source_file (_tmp271_, _tmp272_);
	_tmp273_ = vala_code_context_get_analyzer (context);
	_tmp274_ = _tmp273_;
	_tmp275_ = old_symbol;
	vala_semantic_analyzer_set_current_symbol (_tmp274_, _tmp275_);
	_tmp276_ = vala_code_node_get_error ((ValaCodeNode*) self);
	_tmp277_ = _tmp276_;
	result = !_tmp277_;
	_vala_code_node_unref0 (old_symbol);
	_vala_source_file_unref0 (old_source_file);
	return result;
}

static void
vala_field_class_init (ValaFieldClass * klass,
                       gpointer klass_data)
{
	vala_field_parent_class = g_type_class_peek_parent (klass);
	((ValaCodeNodeClass *) klass)->finalize = vala_field_finalize;
	g_type_class_adjust_private_offset (klass, &ValaField_private_offset);
	((ValaCodeNodeClass *) klass)->accept = (void (*) (ValaCodeNode*, ValaCodeVisitor*)) vala_field_real_accept;
	((ValaCodeNodeClass *) klass)->accept_children = (void (*) (ValaCodeNode*, ValaCodeVisitor*)) vala_field_real_accept_children;
	((ValaCodeNodeClass *) klass)->replace_expression = (void (*) (ValaCodeNode*, ValaExpression*, ValaExpression*)) vala_field_real_replace_expression;
	((ValaCodeNodeClass *) klass)->replace_type = (void (*) (ValaCodeNode*, ValaDataType*, ValaDataType*)) vala_field_real_replace_type;
	((ValaCodeNodeClass *) klass)->check = (gboolean (*) (ValaCodeNode*, ValaCodeContext*)) vala_field_real_check;
}

static void
vala_field_vala_lockable_interface_init (ValaLockableIface * iface,
                                         gpointer iface_data)
{
	vala_field_vala_lockable_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_lock_used = vala_field_real_get_lock_used;
	iface->set_lock_used = vala_field_real_set_lock_used;
}

static void
vala_field_instance_init (ValaField * self,
                          gpointer klass)
{
	self->priv = vala_field_get_instance_private (self);
	self->priv->_binding = VALA_MEMBER_BINDING_INSTANCE;
}

static void
vala_field_finalize (ValaCodeNode * obj)
{
	ValaField * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_TYPE_FIELD, ValaField);
	VALA_CODE_NODE_CLASS (vala_field_parent_class)->finalize (obj);
}

/**
 * Represents a type or namespace field.
 */
static GType
vala_field_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ValaFieldClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_field_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaField), 0, (GInstanceInitFunc) vala_field_instance_init, NULL };
	static const GInterfaceInfo vala_lockable_info = { (GInterfaceInitFunc) vala_field_vala_lockable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType vala_field_type_id;
	vala_field_type_id = g_type_register_static (VALA_TYPE_VARIABLE, "ValaField", &g_define_type_info, 0);
	g_type_add_interface_static (vala_field_type_id, VALA_TYPE_LOCKABLE, &vala_lockable_info);
	ValaField_private_offset = g_type_add_instance_private (vala_field_type_id, sizeof (ValaFieldPrivate));
	return vala_field_type_id;
}

GType
vala_field_get_type (void)
{
	static volatile gsize vala_field_type_id__once = 0;
	if (g_once_init_enter (&vala_field_type_id__once)) {
		GType vala_field_type_id;
		vala_field_type_id = vala_field_get_type_once ();
		g_once_init_leave (&vala_field_type_id__once, vala_field_type_id);
	}
	return vala_field_type_id__once;
}

