/* valaintegerliteral.c generated by valac, the Vala compiler
 * generated from valaintegerliteral.vala, do not modify */

/* valaintegerliteral.vala
 *
 * Copyright (C) 2006-2010  Jürg Billeter
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 */

#include "vala.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <errno.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))

struct _ValaIntegerLiteralPrivate {
	gchar* _value;
	gchar* _type_suffix;
};

static gint ValaIntegerLiteral_private_offset;
static gpointer vala_integer_literal_parent_class = NULL;

static void vala_integer_literal_set_value (ValaIntegerLiteral* self,
                                     const gchar* value);
static void vala_integer_literal_set_type_suffix (ValaIntegerLiteral* self,
                                           const gchar* value);
static void vala_integer_literal_real_accept (ValaCodeNode* base,
                                       ValaCodeVisitor* visitor);
static gchar* vala_integer_literal_real_to_string (ValaCodeNode* base);
static gboolean vala_integer_literal_real_is_pure (ValaExpression* base);
static gboolean vala_integer_literal_real_check (ValaCodeNode* base,
                                          ValaCodeContext* context);
static void vala_integer_literal_real_emit (ValaCodeNode* base,
                                     ValaCodeGenerator* codegen);
static void vala_integer_literal_finalize (ValaCodeNode * obj);
static GType vala_integer_literal_get_type_once (void);

static inline gpointer
vala_integer_literal_get_instance_private (ValaIntegerLiteral* self)
{
	return G_STRUCT_MEMBER_P (self, ValaIntegerLiteral_private_offset);
}

const gchar*
vala_integer_literal_get_value (ValaIntegerLiteral* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_value;
	result = _tmp0_;
	return result;
}

static void
vala_integer_literal_set_value (ValaIntegerLiteral* self,
                                const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_value);
	self->priv->_value = _tmp0_;
}

const gchar*
vala_integer_literal_get_type_suffix (ValaIntegerLiteral* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_type_suffix;
	result = _tmp0_;
	return result;
}

static void
vala_integer_literal_set_type_suffix (ValaIntegerLiteral* self,
                                      const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_type_suffix);
	self->priv->_type_suffix = _tmp0_;
}

/**
 * Creates a new integer literal.
 *
 * @param i      literal value
 * @param source reference to source code
 * @return       newly created integer literal
 */
ValaIntegerLiteral*
vala_integer_literal_construct (GType object_type,
                                const gchar* i,
                                ValaSourceReference* source)
{
	ValaIntegerLiteral* self = NULL;
	g_return_val_if_fail (i != NULL, NULL);
	self = (ValaIntegerLiteral*) vala_literal_construct (object_type);
	vala_integer_literal_set_value (self, i);
	vala_code_node_set_source_reference ((ValaCodeNode*) self, source);
	return self;
}

ValaIntegerLiteral*
vala_integer_literal_new (const gchar* i,
                          ValaSourceReference* source)
{
	return vala_integer_literal_construct (VALA_TYPE_INTEGER_LITERAL, i, source);
}

static void
vala_integer_literal_real_accept (ValaCodeNode* base,
                                  ValaCodeVisitor* visitor)
{
	ValaIntegerLiteral * self;
	self = (ValaIntegerLiteral*) base;
	g_return_if_fail (visitor != NULL);
	vala_code_visitor_visit_integer_literal (visitor, self);
	vala_code_visitor_visit_expression (visitor, (ValaExpression*) self);
}

static gchar*
vala_integer_literal_real_to_string (ValaCodeNode* base)
{
	ValaIntegerLiteral * self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
	self = (ValaIntegerLiteral*) base;
	_tmp0_ = self->priv->_value;
	_tmp1_ = g_strdup (_tmp0_);
	result = _tmp1_;
	return result;
}

static gboolean
vala_integer_literal_real_is_pure (ValaExpression* base)
{
	ValaIntegerLiteral * self;
	gboolean result;
	self = (ValaIntegerLiteral*) base;
	result = TRUE;
	return result;
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
	end = _tmp0_;
	_tmp1_ = end;
	if (_tmp1_ == NULL) {
		result = maxlen;
		return result;
	} else {
		gchar* _tmp2_;
		_tmp2_ = end;
		result = (glong) (_tmp2_ - str);
		return result;
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	if (offset >= ((glong) 0)) {
		_tmp0_ = len >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		string_length = string_strnlen ((gchar*) self, offset + len);
	} else {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = strlen (self);
		_tmp2_ = _tmp1_;
		string_length = (glong) _tmp2_;
	}
	if (offset < ((glong) 0)) {
		offset = string_length + offset;
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
	} else {
		g_return_val_if_fail (offset <= string_length, NULL);
	}
	if (len < ((glong) 0)) {
		len = string_length - offset;
	}
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
	result = _tmp3_;
	return result;
}

static gboolean
int64_try_parse (const gchar* str,
                 gint64* _result_,
                 const gchar** unparsed,
                 guint _base)
{
	gint64 _vala__result_ = 0LL;
	const gchar* _vala_unparsed = NULL;
	gchar* endptr = NULL;
	gchar* _tmp0_ = NULL;
	gint64 _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean result;
	g_return_val_if_fail (str != NULL, FALSE);
	errno = 0;
	_tmp1_ = g_ascii_strtoll (str, &_tmp0_, _base);
	endptr = _tmp0_;
	_vala__result_ = _tmp1_;
	_tmp2_ = endptr;
	_tmp3_ = strlen (str);
	_tmp4_ = _tmp3_;
	if (_tmp2_ == (((gchar*) str) + _tmp4_)) {
		gboolean _tmp5_ = FALSE;
		_vala_unparsed = "";
		if (errno != ERANGE) {
			_tmp5_ = errno != EINVAL;
		} else {
			_tmp5_ = FALSE;
		}
		result = _tmp5_;
		if (_result_) {
			*_result_ = _vala__result_;
		}
		if (unparsed) {
			*unparsed = _vala_unparsed;
		}
		return result;
	} else {
		gchar* _tmp6_;
		_tmp6_ = endptr;
		_vala_unparsed = (const gchar*) _tmp6_;
		result = FALSE;
		if (_result_) {
			*_result_ = _vala__result_;
		}
		if (unparsed) {
			*unparsed = _vala_unparsed;
		}
		return result;
	}
}

static gboolean
uint64_try_parse (const gchar* str,
                  guint64* _result_,
                  const gchar** unparsed,
                  guint _base)
{
	guint64 _vala__result_ = 0ULL;
	const gchar* _vala_unparsed = NULL;
	gchar* endptr = NULL;
	gchar* _tmp0_ = NULL;
	guint64 _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean result;
	g_return_val_if_fail (str != NULL, FALSE);
	errno = 0;
	_tmp1_ = g_ascii_strtoull (str, &_tmp0_, _base);
	endptr = _tmp0_;
	_vala__result_ = _tmp1_;
	_tmp2_ = endptr;
	_tmp3_ = strlen (str);
	_tmp4_ = _tmp3_;
	if (_tmp2_ == (((gchar*) str) + _tmp4_)) {
		gboolean _tmp5_ = FALSE;
		_vala_unparsed = "";
		if (errno != ERANGE) {
			_tmp5_ = errno != EINVAL;
		} else {
			_tmp5_ = FALSE;
		}
		result = _tmp5_;
		if (_result_) {
			*_result_ = _vala__result_;
		}
		if (unparsed) {
			*unparsed = _vala_unparsed;
		}
		return result;
	} else {
		gchar* _tmp6_;
		_tmp6_ = endptr;
		_vala_unparsed = (const gchar*) _tmp6_;
		result = FALSE;
		if (_result_) {
			*_result_ = _vala__result_;
		}
		if (unparsed) {
			*unparsed = _vala_unparsed;
		}
		return result;
	}
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}

static gint64
int64_parse (const gchar* str,
             guint _base)
{
	gint64 result;
	g_return_val_if_fail (str != NULL, 0LL);
	result = g_ascii_strtoll (str, NULL, _base);
	return result;
}

static guint64
uint64_parse (const gchar* str,
              guint _base)
{
	guint64 result;
	g_return_val_if_fail (str != NULL, 0ULL);
	result = g_ascii_strtoull (str, NULL, _base);
	return result;
}

static gboolean
vala_integer_literal_real_check (ValaCodeNode* base,
                                 ValaCodeContext* context)
{
	ValaIntegerLiteral * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gint l = 0;
	gboolean u = FALSE;
	gboolean _tmp14_ = FALSE;
	const gchar* _tmp15_;
	gboolean negative = FALSE;
	const gchar* _tmp23_;
	gboolean _tmp24_ = FALSE;
	gint64 n = 0LL;
	guint64 un = 0ULL;
	gboolean _tmp27_ = FALSE;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp29_ = FALSE;
	const gchar* _tmp30_;
	gboolean _tmp109_ = FALSE;
	gchar* type_name = NULL;
	ValaStruct* st = NULL;
	ValaNamespace* _tmp118_;
	ValaNamespace* _tmp119_;
	ValaScope* _tmp120_;
	ValaScope* _tmp121_;
	const gchar* _tmp122_;
	ValaSymbol* _tmp123_;
	ValaStruct* _tmp124_;
	ValaStruct* _tmp125_;
	const gchar* _tmp126_;
	const gchar* _tmp127_;
	ValaIntegerType* _tmp128_;
	ValaIntegerType* _tmp129_;
	gboolean _tmp130_;
	gboolean _tmp131_;
	gboolean result;
	self = (ValaIntegerLiteral*) base;
	g_return_val_if_fail (context != NULL, FALSE);
	_tmp0_ = vala_code_node_get_checked ((ValaCodeNode*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		gboolean _tmp2_;
		gboolean _tmp3_;
		_tmp2_ = vala_code_node_get_error ((ValaCodeNode*) self);
		_tmp3_ = _tmp2_;
		result = !_tmp3_;
		return result;
	}
	vala_code_node_set_checked ((ValaCodeNode*) self, TRUE);
	l = 0;
	while (TRUE) {
		gboolean _tmp4_ = FALSE;
		const gchar* _tmp5_;
		gint _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		_tmp5_ = self->priv->_value;
		if (g_str_has_suffix (_tmp5_, "l")) {
			_tmp4_ = TRUE;
		} else {
			const gchar* _tmp6_;
			_tmp6_ = self->priv->_value;
			_tmp4_ = g_str_has_suffix (_tmp6_, "L");
		}
		if (!_tmp4_) {
			break;
		}
		_tmp7_ = l;
		l = _tmp7_ + 1;
		_tmp8_ = self->priv->_value;
		_tmp9_ = self->priv->_value;
		_tmp10_ = strlen (_tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = string_substring (_tmp8_, (glong) 0, (glong) (_tmp11_ - 1));
		_tmp13_ = _tmp12_;
		vala_integer_literal_set_value (self, _tmp13_);
		_g_free0 (_tmp13_);
	}
	u = FALSE;
	_tmp15_ = self->priv->_value;
	if (g_str_has_suffix (_tmp15_, "u")) {
		_tmp14_ = TRUE;
	} else {
		const gchar* _tmp16_;
		_tmp16_ = self->priv->_value;
		_tmp14_ = g_str_has_suffix (_tmp16_, "U");
	}
	if (_tmp14_) {
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		gint _tmp19_;
		gint _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		u = TRUE;
		_tmp17_ = self->priv->_value;
		_tmp18_ = self->priv->_value;
		_tmp19_ = strlen (_tmp18_);
		_tmp20_ = _tmp19_;
		_tmp21_ = string_substring (_tmp17_, (glong) 0, (glong) (_tmp20_ - 1));
		_tmp22_ = _tmp21_;
		vala_integer_literal_set_value (self, _tmp22_);
		_g_free0 (_tmp22_);
	}
	_tmp23_ = self->priv->_value;
	negative = g_str_has_prefix (_tmp23_, "-");
	if (negative) {
		_tmp24_ = u;
	} else {
		_tmp24_ = FALSE;
	}
	if (_tmp24_) {
		ValaSourceReference* _tmp25_;
		ValaSourceReference* _tmp26_;
		_tmp25_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp26_ = _tmp25_;
		vala_report_error (_tmp26_, "unsigned integer literal cannot be negative");
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
	}
	n = 0LL;
	un = 0ULL;
	errno = 0;
	_tmp30_ = self->priv->_value;
	if (g_str_has_prefix (_tmp30_, "0b")) {
		_tmp29_ = TRUE;
	} else {
		const gchar* _tmp31_;
		_tmp31_ = self->priv->_value;
		_tmp29_ = g_str_has_prefix (_tmp31_, "0B");
	}
	if (_tmp29_) {
		_tmp28_ = TRUE;
	} else {
		const gchar* _tmp32_;
		_tmp32_ = self->priv->_value;
		_tmp28_ = g_str_has_prefix (_tmp32_, "-0b");
	}
	if (_tmp28_) {
		_tmp27_ = TRUE;
	} else {
		const gchar* _tmp33_;
		_tmp33_ = self->priv->_value;
		_tmp27_ = g_str_has_prefix (_tmp33_, "-0B");
	}
	if (_tmp27_) {
		gchar* v = NULL;
		gchar* unparsed = NULL;
		const gchar* _tmp52_;
		if (negative) {
			const gchar* _tmp34_;
			gchar* _tmp35_;
			gchar* _tmp36_;
			gchar* _tmp37_;
			_tmp34_ = self->priv->_value;
			_tmp35_ = string_substring (_tmp34_, (glong) 3, (glong) -1);
			_tmp36_ = _tmp35_;
			_tmp37_ = g_strconcat ("-", _tmp36_, NULL);
			_g_free0 (v);
			v = _tmp37_;
			_g_free0 (_tmp36_);
		} else {
			const gchar* _tmp38_;
			gchar* _tmp39_;
			_tmp38_ = self->priv->_value;
			_tmp39_ = string_substring (_tmp38_, (glong) 2, (glong) -1);
			_g_free0 (v);
			v = _tmp39_;
		}
		if (negative) {
			const gchar* _tmp40_;
			gint64 _tmp41_ = 0LL;
			const gchar* _tmp42_ = NULL;
			gchar* _tmp43_;
			gchar* _tmp44_;
			gchar* _tmp45_;
			_tmp40_ = v;
			int64_try_parse (_tmp40_, &_tmp41_, &_tmp42_, (guint) 2);
			n = _tmp41_;
			_g_free0 (unparsed);
			_tmp43_ = g_strdup (_tmp42_);
			unparsed = _tmp43_;
			_tmp44_ = g_strdup_printf ("%" G_GINT64_FORMAT, n);
			_tmp45_ = _tmp44_;
			vala_integer_literal_set_value (self, _tmp45_);
			_g_free0 (_tmp45_);
		} else {
			const gchar* _tmp46_;
			guint64 _tmp47_ = 0ULL;
			const gchar* _tmp48_ = NULL;
			gchar* _tmp49_;
			gchar* _tmp50_;
			gchar* _tmp51_;
			_tmp46_ = v;
			uint64_try_parse (_tmp46_, &_tmp47_, &_tmp48_, (guint) 2);
			un = _tmp47_;
			_g_free0 (unparsed);
			_tmp49_ = g_strdup (_tmp48_);
			unparsed = _tmp49_;
			_tmp50_ = g_strdup_printf ("%" G_GUINT64_FORMAT, un);
			_tmp51_ = _tmp50_;
			vala_integer_literal_set_value (self, _tmp51_);
			_g_free0 (_tmp51_);
		}
		_tmp52_ = unparsed;
		if (g_strcmp0 (_tmp52_, "") != 0) {
			ValaSourceReference* _tmp53_;
			ValaSourceReference* _tmp54_;
			const gchar* _tmp55_;
			_tmp53_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp54_ = _tmp53_;
			_tmp55_ = unparsed;
			vala_report_error (_tmp54_, "invalid digit '%c' in binary literal", (gint) string_get (_tmp55_, (glong) 0));
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		}
		_g_free0 (unparsed);
		_g_free0 (v);
	} else {
		gboolean _tmp56_ = FALSE;
		gboolean _tmp57_ = FALSE;
		gboolean _tmp58_ = FALSE;
		const gchar* _tmp59_;
		_tmp59_ = self->priv->_value;
		if (string_get (_tmp59_, (glong) 0) == '0') {
			const gchar* _tmp60_;
			gint _tmp61_;
			gint _tmp62_;
			_tmp60_ = self->priv->_value;
			_tmp61_ = strlen (_tmp60_);
			_tmp62_ = _tmp61_;
			_tmp58_ = _tmp62_ > 1;
		} else {
			_tmp58_ = FALSE;
		}
		if (_tmp58_) {
			gboolean _tmp63_ = FALSE;
			gboolean _tmp64_ = FALSE;
			const gchar* _tmp65_;
			_tmp65_ = self->priv->_value;
			if (string_get (_tmp65_, (glong) 1) == 'o') {
				_tmp64_ = TRUE;
			} else {
				const gchar* _tmp66_;
				_tmp66_ = self->priv->_value;
				_tmp64_ = string_get (_tmp66_, (glong) 1) == 'O';
			}
			if (_tmp64_) {
				_tmp63_ = TRUE;
			} else {
				const gchar* _tmp67_;
				_tmp67_ = self->priv->_value;
				_tmp63_ = g_ascii_isdigit (string_get (_tmp67_, (glong) 1));
			}
			_tmp57_ = _tmp63_;
		} else {
			_tmp57_ = FALSE;
		}
		if (_tmp57_) {
			_tmp56_ = TRUE;
		} else {
			gboolean _tmp68_ = FALSE;
			gboolean _tmp69_ = FALSE;
			const gchar* _tmp70_;
			_tmp70_ = self->priv->_value;
			if (g_str_has_prefix (_tmp70_, "-0")) {
				const gchar* _tmp71_;
				gint _tmp72_;
				gint _tmp73_;
				_tmp71_ = self->priv->_value;
				_tmp72_ = strlen (_tmp71_);
				_tmp73_ = _tmp72_;
				_tmp69_ = _tmp73_ > 3;
			} else {
				_tmp69_ = FALSE;
			}
			if (_tmp69_) {
				gboolean _tmp74_ = FALSE;
				gboolean _tmp75_ = FALSE;
				const gchar* _tmp76_;
				_tmp76_ = self->priv->_value;
				if (string_get (_tmp76_, (glong) 2) == 'o') {
					_tmp75_ = TRUE;
				} else {
					const gchar* _tmp77_;
					_tmp77_ = self->priv->_value;
					_tmp75_ = string_get (_tmp77_, (glong) 2) == 'O';
				}
				if (_tmp75_) {
					_tmp74_ = TRUE;
				} else {
					const gchar* _tmp78_;
					_tmp78_ = self->priv->_value;
					_tmp74_ = g_ascii_isdigit (string_get (_tmp78_, (glong) 2));
				}
				_tmp68_ = _tmp74_;
			} else {
				_tmp68_ = FALSE;
			}
			_tmp56_ = _tmp68_;
		}
		if (_tmp56_) {
			gchar* unparsed = NULL;
			const gchar* _tmp99_;
			if (negative) {
				const gchar* _tmp79_;
				_tmp79_ = self->priv->_value;
				if (!g_ascii_isdigit (string_get (_tmp79_, (glong) 2))) {
					const gchar* _tmp80_;
					gchar* _tmp81_;
					gchar* _tmp82_;
					gchar* _tmp83_;
					gchar* _tmp84_;
					_tmp80_ = self->priv->_value;
					_tmp81_ = string_substring (_tmp80_, (glong) 3, (glong) -1);
					_tmp82_ = _tmp81_;
					_tmp83_ = g_strconcat ("-0", _tmp82_, NULL);
					_tmp84_ = _tmp83_;
					vala_integer_literal_set_value (self, _tmp84_);
					_g_free0 (_tmp84_);
					_g_free0 (_tmp82_);
				}
			} else {
				const gchar* _tmp85_;
				_tmp85_ = self->priv->_value;
				if (!g_ascii_isdigit (string_get (_tmp85_, (glong) 1))) {
					const gchar* _tmp86_;
					gchar* _tmp87_;
					gchar* _tmp88_;
					gchar* _tmp89_;
					gchar* _tmp90_;
					_tmp86_ = self->priv->_value;
					_tmp87_ = string_substring (_tmp86_, (glong) 2, (glong) -1);
					_tmp88_ = _tmp87_;
					_tmp89_ = g_strconcat ("0", _tmp88_, NULL);
					_tmp90_ = _tmp89_;
					vala_integer_literal_set_value (self, _tmp90_);
					_g_free0 (_tmp90_);
					_g_free0 (_tmp88_);
				}
			}
			if (negative) {
				const gchar* _tmp91_;
				gint64 _tmp92_ = 0LL;
				const gchar* _tmp93_ = NULL;
				gchar* _tmp94_;
				_tmp91_ = self->priv->_value;
				int64_try_parse (_tmp91_, &_tmp92_, &_tmp93_, (guint) 8);
				n = _tmp92_;
				_g_free0 (unparsed);
				_tmp94_ = g_strdup (_tmp93_);
				unparsed = _tmp94_;
			} else {
				const gchar* _tmp95_;
				guint64 _tmp96_ = 0ULL;
				const gchar* _tmp97_ = NULL;
				gchar* _tmp98_;
				_tmp95_ = self->priv->_value;
				uint64_try_parse (_tmp95_, &_tmp96_, &_tmp97_, (guint) 8);
				un = _tmp96_;
				_g_free0 (unparsed);
				_tmp98_ = g_strdup (_tmp97_);
				unparsed = _tmp98_;
			}
			_tmp99_ = unparsed;
			if (g_strcmp0 (_tmp99_, "") != 0) {
				ValaSourceReference* _tmp100_;
				ValaSourceReference* _tmp101_;
				const gchar* _tmp102_;
				_tmp100_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp101_ = _tmp100_;
				_tmp102_ = unparsed;
				vala_report_error (_tmp101_, "invalid digit '%c' in octal literal", (gint) string_get (_tmp102_, (glong) 0));
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			}
			_g_free0 (unparsed);
		} else {
			if (negative) {
				const gchar* _tmp103_;
				_tmp103_ = self->priv->_value;
				n = int64_parse (_tmp103_, (guint) 0);
			} else {
				const gchar* _tmp104_;
				_tmp104_ = self->priv->_value;
				un = uint64_parse (_tmp104_, (guint) 0);
			}
		}
	}
	if (errno == ERANGE) {
		ValaSourceReference* _tmp105_;
		ValaSourceReference* _tmp106_;
		_tmp105_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp106_ = _tmp105_;
		vala_report_error (_tmp106_, "integer literal is too large for its type");
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
	} else {
		if (errno == EINVAL) {
			ValaSourceReference* _tmp107_;
			ValaSourceReference* _tmp108_;
			_tmp107_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp108_ = _tmp107_;
			vala_report_error (_tmp108_, "invalid integer literal");
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		}
	}
	if (un > ((guint64) G_MAXINT64)) {
		u = TRUE;
		l = 2;
	} else {
		if (!negative) {
			n = (gint64) un;
		}
	}
	if (!u) {
		gboolean _tmp110_ = FALSE;
		if (n > ((gint64) G_MAXINT)) {
			_tmp110_ = TRUE;
		} else {
			_tmp110_ = n < ((gint64) G_MININT);
		}
		_tmp109_ = _tmp110_;
	} else {
		_tmp109_ = FALSE;
	}
	if (_tmp109_) {
		l = 2;
	} else {
		gboolean _tmp111_ = FALSE;
		if (u) {
			_tmp111_ = n > ((gint64) G_MAXUINT);
		} else {
			_tmp111_ = FALSE;
		}
		if (_tmp111_) {
			l = 2;
		}
	}
	if (l == 0) {
		if (u) {
			gchar* _tmp112_;
			vala_integer_literal_set_type_suffix (self, "U");
			_tmp112_ = g_strdup ("uint");
			_g_free0 (type_name);
			type_name = _tmp112_;
		} else {
			gchar* _tmp113_;
			vala_integer_literal_set_type_suffix (self, "");
			_tmp113_ = g_strdup ("int");
			_g_free0 (type_name);
			type_name = _tmp113_;
		}
	} else {
		if (l == 1) {
			if (u) {
				gchar* _tmp114_;
				vala_integer_literal_set_type_suffix (self, "UL");
				_tmp114_ = g_strdup ("ulong");
				_g_free0 (type_name);
				type_name = _tmp114_;
			} else {
				gchar* _tmp115_;
				vala_integer_literal_set_type_suffix (self, "L");
				_tmp115_ = g_strdup ("long");
				_g_free0 (type_name);
				type_name = _tmp115_;
			}
		} else {
			if (u) {
				gchar* _tmp116_;
				vala_integer_literal_set_type_suffix (self, "ULL");
				_tmp116_ = g_strdup ("uint64");
				_g_free0 (type_name);
				type_name = _tmp116_;
			} else {
				gchar* _tmp117_;
				vala_integer_literal_set_type_suffix (self, "LL");
				_tmp117_ = g_strdup ("int64");
				_g_free0 (type_name);
				type_name = _tmp117_;
			}
		}
	}
	_tmp118_ = vala_code_context_get_root (context);
	_tmp119_ = _tmp118_;
	_tmp120_ = vala_symbol_get_scope ((ValaSymbol*) _tmp119_);
	_tmp121_ = _tmp120_;
	_tmp122_ = type_name;
	_tmp123_ = vala_scope_lookup (_tmp121_, _tmp122_);
	st = G_TYPE_CHECK_INSTANCE_CAST (_tmp123_, VALA_TYPE_STRUCT, ValaStruct);
	_tmp124_ = st;
	vala_code_node_check ((ValaCodeNode*) _tmp124_, context);
	_tmp125_ = st;
	_tmp126_ = self->priv->_value;
	_tmp127_ = type_name;
	_tmp128_ = vala_integer_type_new (_tmp125_, _tmp126_, _tmp127_, NULL);
	_tmp129_ = _tmp128_;
	vala_expression_set_value_type ((ValaExpression*) self, (ValaDataType*) _tmp129_);
	_vala_code_node_unref0 (_tmp129_);
	_tmp130_ = vala_code_node_get_error ((ValaCodeNode*) self);
	_tmp131_ = _tmp130_;
	result = !_tmp131_;
	_vala_code_node_unref0 (st);
	_g_free0 (type_name);
	return result;
}

static void
vala_integer_literal_real_emit (ValaCodeNode* base,
                                ValaCodeGenerator* codegen)
{
	ValaIntegerLiteral * self;
	self = (ValaIntegerLiteral*) base;
	g_return_if_fail (codegen != NULL);
	vala_code_visitor_visit_integer_literal ((ValaCodeVisitor*) codegen, self);
	vala_code_visitor_visit_expression ((ValaCodeVisitor*) codegen, (ValaExpression*) self);
}

static void
vala_integer_literal_class_init (ValaIntegerLiteralClass * klass,
                                 gpointer klass_data)
{
	vala_integer_literal_parent_class = g_type_class_peek_parent (klass);
	((ValaCodeNodeClass *) klass)->finalize = vala_integer_literal_finalize;
	g_type_class_adjust_private_offset (klass, &ValaIntegerLiteral_private_offset);
	((ValaCodeNodeClass *) klass)->accept = (void (*) (ValaCodeNode*, ValaCodeVisitor*)) vala_integer_literal_real_accept;
	((ValaCodeNodeClass *) klass)->to_string = (gchar* (*) (ValaCodeNode*)) vala_integer_literal_real_to_string;
	((ValaExpressionClass *) klass)->is_pure = (gboolean (*) (ValaExpression*)) vala_integer_literal_real_is_pure;
	((ValaCodeNodeClass *) klass)->check = (gboolean (*) (ValaCodeNode*, ValaCodeContext*)) vala_integer_literal_real_check;
	((ValaCodeNodeClass *) klass)->emit = (void (*) (ValaCodeNode*, ValaCodeGenerator*)) vala_integer_literal_real_emit;
}

static void
vala_integer_literal_instance_init (ValaIntegerLiteral * self,
                                    gpointer klass)
{
	self->priv = vala_integer_literal_get_instance_private (self);
}

static void
vala_integer_literal_finalize (ValaCodeNode * obj)
{
	ValaIntegerLiteral * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_TYPE_INTEGER_LITERAL, ValaIntegerLiteral);
	_g_free0 (self->priv->_value);
	_g_free0 (self->priv->_type_suffix);
	VALA_CODE_NODE_CLASS (vala_integer_literal_parent_class)->finalize (obj);
}

/**
 * Represents an integer literal in the source code.
 */
static GType
vala_integer_literal_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ValaIntegerLiteralClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_integer_literal_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaIntegerLiteral), 0, (GInstanceInitFunc) vala_integer_literal_instance_init, NULL };
	GType vala_integer_literal_type_id;
	vala_integer_literal_type_id = g_type_register_static (VALA_TYPE_LITERAL, "ValaIntegerLiteral", &g_define_type_info, 0);
	ValaIntegerLiteral_private_offset = g_type_add_instance_private (vala_integer_literal_type_id, sizeof (ValaIntegerLiteralPrivate));
	return vala_integer_literal_type_id;
}

GType
vala_integer_literal_get_type (void)
{
	static volatile gsize vala_integer_literal_type_id__once = 0;
	if (g_once_init_enter (&vala_integer_literal_type_id__once)) {
		GType vala_integer_literal_type_id;
		vala_integer_literal_type_id = vala_integer_literal_get_type_once ();
		g_once_init_leave (&vala_integer_literal_type_id__once, vala_integer_literal_type_id);
	}
	return vala_integer_literal_type_id__once;
}

