/* valalocalvariable.c generated by valac, the Vala compiler
 * generated from valalocalvariable.vala, do not modify */

/* valalocalvariable.vala
 *
 * Copyright (C) 2006-2010  Jürg Billeter
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 */

#include "vala.h"
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _ValaLocalVariablePrivate {
	gboolean _is_result;
	gboolean _captured;
	gboolean _init;
};

static gint ValaLocalVariable_private_offset;
static gpointer vala_local_variable_parent_class = NULL;

static void vala_local_variable_real_accept (ValaCodeNode* base,
                                      ValaCodeVisitor* visitor);
static void vala_local_variable_real_accept_children (ValaCodeNode* base,
                                               ValaCodeVisitor* visitor);
static void vala_local_variable_real_replace_expression (ValaCodeNode* base,
                                                  ValaExpression* old_node,
                                                  ValaExpression* new_node);
static void vala_local_variable_real_replace_type (ValaCodeNode* base,
                                            ValaDataType* old_type,
                                            ValaDataType* new_type);
static gboolean vala_local_variable_real_check (ValaCodeNode* base,
                                         ValaCodeContext* context);
static void vala_local_variable_finalize (ValaCodeNode * obj);
static GType vala_local_variable_get_type_once (void);

static inline gpointer
vala_local_variable_get_instance_private (ValaLocalVariable* self)
{
	return G_STRUCT_MEMBER_P (self, ValaLocalVariable_private_offset);
}

gboolean
vala_local_variable_get_is_result (ValaLocalVariable* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_is_result;
	return result;
}

void
vala_local_variable_set_is_result (ValaLocalVariable* self,
                                   gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_is_result = value;
}

gboolean
vala_local_variable_get_captured (ValaLocalVariable* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_captured;
	return result;
}

void
vala_local_variable_set_captured (ValaLocalVariable* self,
                                  gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_captured = value;
}

gboolean
vala_local_variable_get_init (ValaLocalVariable* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_init;
	return result;
}

void
vala_local_variable_set_init (ValaLocalVariable* self,
                              gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_init = value;
}

/**
 * Creates a new local variable.
 *
 * @param name              name of the variable
 * @param initializer       optional initializer expression
 * @param source_reference  reference to source code
 * @return                  newly created variable declarator
 */
ValaLocalVariable*
vala_local_variable_construct (GType object_type,
                               ValaDataType* variable_type,
                               const gchar* name,
                               ValaExpression* initializer,
                               ValaSourceReference* source_reference)
{
	ValaLocalVariable* self = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	self = (ValaLocalVariable*) vala_variable_construct (object_type, variable_type, name, initializer, source_reference, NULL);
	return self;
}

ValaLocalVariable*
vala_local_variable_new (ValaDataType* variable_type,
                         const gchar* name,
                         ValaExpression* initializer,
                         ValaSourceReference* source_reference)
{
	return vala_local_variable_construct (VALA_TYPE_LOCAL_VARIABLE, variable_type, name, initializer, source_reference);
}

static void
vala_local_variable_real_accept (ValaCodeNode* base,
                                 ValaCodeVisitor* visitor)
{
	ValaLocalVariable * self;
	self = (ValaLocalVariable*) base;
	g_return_if_fail (visitor != NULL);
	vala_code_visitor_visit_local_variable (visitor, self);
}

static void
vala_local_variable_real_accept_children (ValaCodeNode* base,
                                          ValaCodeVisitor* visitor)
{
	ValaLocalVariable * self;
	ValaExpression* _tmp0_;
	ValaExpression* _tmp1_;
	ValaDataType* _tmp6_;
	ValaDataType* _tmp7_;
	self = (ValaLocalVariable*) base;
	g_return_if_fail (visitor != NULL);
	_tmp0_ = vala_variable_get_initializer ((ValaVariable*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != NULL) {
		ValaExpression* _tmp2_;
		ValaExpression* _tmp3_;
		ValaExpression* _tmp4_;
		ValaExpression* _tmp5_;
		_tmp2_ = vala_variable_get_initializer ((ValaVariable*) self);
		_tmp3_ = _tmp2_;
		vala_code_node_accept ((ValaCodeNode*) _tmp3_, visitor);
		_tmp4_ = vala_variable_get_initializer ((ValaVariable*) self);
		_tmp5_ = _tmp4_;
		vala_code_visitor_visit_end_full_expression (visitor, _tmp5_);
	}
	_tmp6_ = vala_variable_get_variable_type ((ValaVariable*) self);
	_tmp7_ = _tmp6_;
	if (_tmp7_ != NULL) {
		ValaDataType* _tmp8_;
		ValaDataType* _tmp9_;
		_tmp8_ = vala_variable_get_variable_type ((ValaVariable*) self);
		_tmp9_ = _tmp8_;
		vala_code_node_accept ((ValaCodeNode*) _tmp9_, visitor);
	}
}

static void
vala_local_variable_real_replace_expression (ValaCodeNode* base,
                                             ValaExpression* old_node,
                                             ValaExpression* new_node)
{
	ValaLocalVariable * self;
	ValaExpression* _tmp0_;
	ValaExpression* _tmp1_;
	self = (ValaLocalVariable*) base;
	g_return_if_fail (old_node != NULL);
	g_return_if_fail (new_node != NULL);
	_tmp0_ = vala_variable_get_initializer ((ValaVariable*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == old_node) {
		vala_variable_set_initializer ((ValaVariable*) self, new_node);
	}
}

static void
vala_local_variable_real_replace_type (ValaCodeNode* base,
                                       ValaDataType* old_type,
                                       ValaDataType* new_type)
{
	ValaLocalVariable * self;
	ValaDataType* _tmp0_;
	ValaDataType* _tmp1_;
	self = (ValaLocalVariable*) base;
	g_return_if_fail (old_type != NULL);
	g_return_if_fail (new_type != NULL);
	_tmp0_ = vala_variable_get_variable_type ((ValaVariable*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == old_type) {
		vala_variable_set_variable_type ((ValaVariable*) self, new_type);
	}
}

static gboolean
vala_local_variable_real_check (ValaCodeNode* base,
                                ValaCodeContext* context)
{
	ValaLocalVariable * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	ValaDataType* _tmp4_;
	ValaDataType* _tmp5_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	ValaDataType* _tmp21_;
	ValaDataType* _tmp22_;
	gboolean is_initializer_list = FALSE;
	gint initializer_size = 0;
	gboolean _tmp37_ = FALSE;
	ValaExpression* _tmp38_;
	ValaExpression* _tmp39_;
	ValaSemanticAnalyzer* _tmp62_;
	ValaSemanticAnalyzer* _tmp63_;
	ValaSymbol* _tmp64_;
	ValaSymbol* _tmp65_;
	ValaScope* _tmp66_;
	ValaScope* _tmp67_;
	const gchar* _tmp68_;
	const gchar* _tmp69_;
	gboolean _tmp70_;
	gboolean _tmp71_;
	ValaDataType* _tmp72_;
	ValaDataType* _tmp73_;
	gboolean _tmp135_;
	gboolean _tmp136_;
	ValaArrayType* variable_array_type = NULL;
	ValaDataType* _tmp149_;
	ValaDataType* _tmp150_;
	gboolean _tmp151_ = FALSE;
	gboolean _tmp152_ = FALSE;
	gboolean _tmp153_ = FALSE;
	ValaArrayType* _tmp154_;
	gboolean _tmp166_ = FALSE;
	gboolean _tmp167_ = FALSE;
	gboolean _tmp168_ = FALSE;
	ValaArrayType* _tmp169_;
	gboolean _tmp180_ = FALSE;
	ValaExpression* _tmp181_;
	ValaExpression* _tmp182_;
	ValaBlock* block = NULL;
	ValaSemanticAnalyzer* _tmp323_;
	ValaSemanticAnalyzer* _tmp324_;
	ValaSymbol* _tmp325_;
	ValaSymbol* _tmp326_;
	ValaBlock* _tmp327_;
	gboolean _tmp329_;
	gboolean _tmp330_;
	gboolean result;
	self = (ValaLocalVariable*) base;
	g_return_val_if_fail (context != NULL, FALSE);
	_tmp0_ = vala_code_node_get_checked ((ValaCodeNode*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		gboolean _tmp2_;
		gboolean _tmp3_;
		_tmp2_ = vala_code_node_get_error ((ValaCodeNode*) self);
		_tmp3_ = _tmp2_;
		result = !_tmp3_;
		return result;
	}
	vala_code_node_set_checked ((ValaCodeNode*) self, TRUE);
	_tmp4_ = vala_variable_get_variable_type ((ValaVariable*) self);
	_tmp5_ = _tmp4_;
	if (_tmp5_ == NULL) {
		ValaVarType* _tmp6_;
		ValaVarType* _tmp7_;
		_tmp6_ = vala_var_type_new (TRUE);
		_tmp7_ = _tmp6_;
		vala_variable_set_variable_type ((ValaVariable*) self, (ValaDataType*) _tmp7_);
		_vala_code_node_unref0 (_tmp7_);
	}
	_tmp8_ = vala_code_context_get_experimental_non_null (context);
	_tmp9_ = _tmp8_;
	if (!_tmp9_) {
		ValaDataType* _tmp10_;
		ValaDataType* _tmp11_;
		_tmp10_ = vala_variable_get_variable_type ((ValaVariable*) self);
		_tmp11_ = _tmp10_;
		if (VALA_IS_REFERENCE_TYPE (_tmp11_)) {
			ValaArrayType* array_type = NULL;
			ValaDataType* _tmp12_;
			ValaDataType* _tmp13_;
			gboolean _tmp14_ = FALSE;
			ValaArrayType* _tmp15_;
			_tmp12_ = vala_variable_get_variable_type ((ValaVariable*) self);
			_tmp13_ = _tmp12_;
			array_type = VALA_IS_ARRAY_TYPE (_tmp13_) ? ((ValaArrayType*) _tmp13_) : NULL;
			_tmp15_ = array_type;
			if (_tmp15_ != NULL) {
				ValaArrayType* _tmp16_;
				gboolean _tmp17_;
				gboolean _tmp18_;
				_tmp16_ = array_type;
				_tmp17_ = vala_array_type_get_fixed_length (_tmp16_);
				_tmp18_ = _tmp17_;
				_tmp14_ = _tmp18_;
			} else {
				_tmp14_ = FALSE;
			}
			if (_tmp14_) {
			} else {
				ValaDataType* _tmp19_;
				ValaDataType* _tmp20_;
				_tmp19_ = vala_variable_get_variable_type ((ValaVariable*) self);
				_tmp20_ = _tmp19_;
				vala_data_type_set_nullable (_tmp20_, TRUE);
			}
		}
	}
	_tmp21_ = vala_variable_get_variable_type ((ValaVariable*) self);
	_tmp22_ = _tmp21_;
	if (!VALA_IS_VAR_TYPE (_tmp22_)) {
		ValaDataType* _tmp23_;
		ValaDataType* _tmp24_;
		gboolean _tmp29_;
		gboolean _tmp30_;
		_tmp23_ = vala_variable_get_variable_type ((ValaVariable*) self);
		_tmp24_ = _tmp23_;
		if (VALA_IS_VOID_TYPE (_tmp24_)) {
			ValaSourceReference* _tmp25_;
			ValaSourceReference* _tmp26_;
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			_tmp25_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp26_ = _tmp25_;
			vala_report_error (_tmp26_, "'void' not supported as variable type");
		} else {
			ValaDataType* _tmp27_;
			ValaDataType* _tmp28_;
			_tmp27_ = vala_variable_get_variable_type ((ValaVariable*) self);
			_tmp28_ = _tmp27_;
			if (!vala_code_node_check ((ValaCodeNode*) _tmp28_, context)) {
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			}
		}
		_tmp29_ = vala_symbol_get_external_package ((ValaSymbol*) self);
		_tmp30_ = _tmp29_;
		if (!_tmp30_) {
			ValaSemanticAnalyzer* _tmp31_;
			ValaSemanticAnalyzer* _tmp32_;
			ValaDataType* _tmp33_;
			ValaDataType* _tmp34_;
			ValaDataType* _tmp35_;
			ValaDataType* _tmp36_;
			_tmp31_ = vala_code_context_get_analyzer (context);
			_tmp32_ = _tmp31_;
			_tmp33_ = vala_variable_get_variable_type ((ValaVariable*) self);
			_tmp34_ = _tmp33_;
			vala_semantic_analyzer_check_type (_tmp32_, _tmp34_);
			_tmp35_ = vala_variable_get_variable_type ((ValaVariable*) self);
			_tmp36_ = _tmp35_;
			vala_data_type_check_type_arguments (_tmp36_, context, TRUE);
		}
	}
	is_initializer_list = FALSE;
	initializer_size = -1;
	_tmp38_ = vala_variable_get_initializer ((ValaVariable*) self);
	_tmp39_ = _tmp38_;
	if (_tmp39_ != NULL) {
		gboolean _tmp40_;
		gboolean _tmp41_;
		_tmp40_ = vala_code_node_get_error ((ValaCodeNode*) self);
		_tmp41_ = _tmp40_;
		_tmp37_ = !_tmp41_;
	} else {
		_tmp37_ = FALSE;
	}
	if (_tmp37_) {
		ValaExpression* _tmp42_;
		ValaExpression* _tmp43_;
		ValaDataType* _tmp44_;
		ValaDataType* _tmp45_;
		ValaExpression* _tmp46_;
		ValaExpression* _tmp47_;
		ValaExpression* _tmp52_;
		ValaExpression* _tmp53_;
		_tmp42_ = vala_variable_get_initializer ((ValaVariable*) self);
		_tmp43_ = _tmp42_;
		_tmp44_ = vala_variable_get_variable_type ((ValaVariable*) self);
		_tmp45_ = _tmp44_;
		vala_expression_set_target_type (_tmp43_, _tmp45_);
		_tmp46_ = vala_variable_get_initializer ((ValaVariable*) self);
		_tmp47_ = _tmp46_;
		if (VALA_IS_INITIALIZER_LIST (_tmp47_)) {
			ValaExpression* _tmp48_;
			ValaExpression* _tmp49_;
			gint _tmp50_;
			gint _tmp51_;
			_tmp48_ = vala_variable_get_initializer ((ValaVariable*) self);
			_tmp49_ = _tmp48_;
			_tmp50_ = vala_initializer_list_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp49_, VALA_TYPE_INITIALIZER_LIST, ValaInitializerList));
			_tmp51_ = _tmp50_;
			initializer_size = _tmp51_;
			is_initializer_list = TRUE;
		}
		_tmp52_ = vala_variable_get_initializer ((ValaVariable*) self);
		_tmp53_ = _tmp52_;
		if (!vala_code_node_check ((ValaCodeNode*) _tmp53_, context)) {
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		} else {
			ValaExpression* _tmp54_;
			ValaExpression* _tmp55_;
			ValaDataType* _tmp56_;
			ValaDataType* _tmp57_;
			_tmp54_ = vala_variable_get_initializer ((ValaVariable*) self);
			_tmp55_ = _tmp54_;
			_tmp56_ = vala_expression_get_value_type (_tmp55_);
			_tmp57_ = _tmp56_;
			if (VALA_IS_VOID_TYPE (_tmp57_)) {
				ValaExpression* _tmp58_;
				ValaExpression* _tmp59_;
				ValaSourceReference* _tmp60_;
				ValaSourceReference* _tmp61_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp58_ = vala_variable_get_initializer ((ValaVariable*) self);
				_tmp59_ = _tmp58_;
				_tmp60_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp59_);
				_tmp61_ = _tmp60_;
				vala_report_error (_tmp61_, "'void' not supported as initializer type");
			}
		}
	}
	_tmp62_ = vala_code_context_get_analyzer (context);
	_tmp63_ = _tmp62_;
	_tmp64_ = vala_semantic_analyzer_get_current_symbol (_tmp63_);
	_tmp65_ = _tmp64_;
	_tmp66_ = vala_symbol_get_scope (_tmp65_);
	_tmp67_ = _tmp66_;
	_tmp68_ = vala_symbol_get_name ((ValaSymbol*) self);
	_tmp69_ = _tmp68_;
	vala_scope_add (_tmp67_, _tmp69_, (ValaSymbol*) self);
	_tmp70_ = vala_code_node_get_error ((ValaCodeNode*) self);
	_tmp71_ = _tmp70_;
	if (_tmp71_) {
		result = FALSE;
		return result;
	}
	_tmp72_ = vala_variable_get_variable_type ((ValaVariable*) self);
	_tmp73_ = _tmp72_;
	if (VALA_IS_VAR_TYPE (_tmp73_)) {
		ValaExpression* _tmp74_;
		ValaExpression* _tmp75_;
		ValaExpression* _tmp78_;
		ValaExpression* _tmp79_;
		ValaDataType* _tmp80_;
		ValaDataType* _tmp81_;
		gboolean _tmp84_ = FALSE;
		ValaExpression* _tmp85_;
		ValaExpression* _tmp86_;
		ValaDataType* _tmp87_;
		ValaDataType* _tmp88_;
		gboolean nullable = FALSE;
		ValaDataType* _tmp103_;
		ValaDataType* _tmp104_;
		gboolean _tmp105_;
		gboolean _tmp106_;
		gboolean value_owned = FALSE;
		ValaDataType* _tmp107_;
		ValaDataType* _tmp108_;
		gboolean _tmp109_;
		gboolean _tmp110_;
		gboolean is_dynamic = FALSE;
		ValaDataType* _tmp111_;
		ValaDataType* _tmp112_;
		gboolean _tmp113_;
		gboolean _tmp114_;
		ValaExpression* _tmp115_;
		ValaExpression* _tmp116_;
		ValaDataType* _tmp117_;
		ValaDataType* _tmp118_;
		ValaDataType* _tmp119_;
		ValaDataType* _tmp120_;
		ValaDataType* _tmp121_;
		ValaDataType* _tmp122_;
		ValaDataType* _tmp123_;
		ValaDataType* _tmp124_;
		ValaExpression* _tmp129_;
		ValaExpression* _tmp130_;
		ValaDataType* _tmp131_;
		ValaDataType* _tmp132_;
		ValaDataType* _tmp133_;
		ValaDataType* _tmp134_;
		_tmp74_ = vala_variable_get_initializer ((ValaVariable*) self);
		_tmp75_ = _tmp74_;
		if (_tmp75_ == NULL) {
			ValaSourceReference* _tmp76_;
			ValaSourceReference* _tmp77_;
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			_tmp76_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp77_ = _tmp76_;
			vala_report_error (_tmp77_, "var declaration not allowed without initializer");
			result = FALSE;
			return result;
		}
		_tmp78_ = vala_variable_get_initializer ((ValaVariable*) self);
		_tmp79_ = _tmp78_;
		_tmp80_ = vala_expression_get_value_type (_tmp79_);
		_tmp81_ = _tmp80_;
		if (_tmp81_ == NULL) {
			ValaSourceReference* _tmp82_;
			ValaSourceReference* _tmp83_;
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			_tmp82_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp83_ = _tmp82_;
			vala_report_error (_tmp83_, "var declaration not allowed with non-typed initializer");
			result = FALSE;
			return result;
		}
		_tmp85_ = vala_variable_get_initializer ((ValaVariable*) self);
		_tmp86_ = _tmp85_;
		_tmp87_ = vala_expression_get_value_type (_tmp86_);
		_tmp88_ = _tmp87_;
		if (VALA_IS_FIELD_PROTOTYPE (_tmp88_)) {
			_tmp84_ = TRUE;
		} else {
			ValaExpression* _tmp89_;
			ValaExpression* _tmp90_;
			ValaDataType* _tmp91_;
			ValaDataType* _tmp92_;
			_tmp89_ = vala_variable_get_initializer ((ValaVariable*) self);
			_tmp90_ = _tmp89_;
			_tmp91_ = vala_expression_get_value_type (_tmp90_);
			_tmp92_ = _tmp91_;
			_tmp84_ = VALA_IS_PROPERTY_PROTOTYPE (_tmp92_);
		}
		if (_tmp84_) {
			ValaExpression* _tmp93_;
			ValaExpression* _tmp94_;
			ValaSourceReference* _tmp95_;
			ValaSourceReference* _tmp96_;
			ValaExpression* _tmp97_;
			ValaExpression* _tmp98_;
			ValaSymbol* _tmp99_;
			ValaSymbol* _tmp100_;
			gchar* _tmp101_;
			gchar* _tmp102_;
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			_tmp93_ = vala_variable_get_initializer ((ValaVariable*) self);
			_tmp94_ = _tmp93_;
			_tmp95_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp94_);
			_tmp96_ = _tmp95_;
			_tmp97_ = vala_variable_get_initializer ((ValaVariable*) self);
			_tmp98_ = _tmp97_;
			_tmp99_ = vala_expression_get_symbol_reference (_tmp98_);
			_tmp100_ = _tmp99_;
			_tmp101_ = vala_symbol_get_full_name (_tmp100_);
			_tmp102_ = _tmp101_;
			vala_report_error (_tmp96_, "Access to instance member `%s' denied", _tmp102_);
			_g_free0 (_tmp102_);
			result = FALSE;
			return result;
		}
		_tmp103_ = vala_variable_get_variable_type ((ValaVariable*) self);
		_tmp104_ = _tmp103_;
		_tmp105_ = vala_data_type_get_nullable (_tmp104_);
		_tmp106_ = _tmp105_;
		nullable = _tmp106_;
		_tmp107_ = vala_variable_get_variable_type ((ValaVariable*) self);
		_tmp108_ = _tmp107_;
		_tmp109_ = vala_data_type_get_value_owned (_tmp108_);
		_tmp110_ = _tmp109_;
		value_owned = _tmp110_;
		_tmp111_ = vala_variable_get_variable_type ((ValaVariable*) self);
		_tmp112_ = _tmp111_;
		_tmp113_ = vala_data_type_get_is_dynamic (_tmp112_);
		_tmp114_ = _tmp113_;
		is_dynamic = _tmp114_;
		_tmp115_ = vala_variable_get_initializer ((ValaVariable*) self);
		_tmp116_ = _tmp115_;
		_tmp117_ = vala_expression_get_value_type (_tmp116_);
		_tmp118_ = _tmp117_;
		_tmp119_ = vala_data_type_copy (_tmp118_);
		_tmp120_ = _tmp119_;
		vala_variable_set_variable_type ((ValaVariable*) self, _tmp120_);
		_vala_code_node_unref0 (_tmp120_);
		_tmp121_ = vala_variable_get_variable_type ((ValaVariable*) self);
		_tmp122_ = _tmp121_;
		vala_data_type_set_value_owned (_tmp122_, value_owned);
		_tmp123_ = vala_variable_get_variable_type ((ValaVariable*) self);
		_tmp124_ = _tmp123_;
		vala_data_type_set_floating_reference (_tmp124_, FALSE);
		if (nullable) {
			ValaDataType* _tmp125_;
			ValaDataType* _tmp126_;
			_tmp125_ = vala_variable_get_variable_type ((ValaVariable*) self);
			_tmp126_ = _tmp125_;
			vala_data_type_set_nullable (_tmp126_, TRUE);
		}
		if (is_dynamic) {
			ValaDataType* _tmp127_;
			ValaDataType* _tmp128_;
			_tmp127_ = vala_variable_get_variable_type ((ValaVariable*) self);
			_tmp128_ = _tmp127_;
			vala_data_type_set_is_dynamic (_tmp128_, TRUE);
		}
		_tmp129_ = vala_variable_get_initializer ((ValaVariable*) self);
		_tmp130_ = _tmp129_;
		_tmp131_ = vala_variable_get_variable_type ((ValaVariable*) self);
		_tmp132_ = _tmp131_;
		vala_expression_set_target_type (_tmp130_, _tmp132_);
		_tmp133_ = vala_variable_get_variable_type ((ValaVariable*) self);
		_tmp134_ = _tmp133_;
		vala_code_node_check ((ValaCodeNode*) _tmp134_, context);
	}
	_tmp135_ = vala_symbol_get_external_package ((ValaSymbol*) self);
	_tmp136_ = _tmp135_;
	if (!_tmp136_) {
		ValaDataType* _tmp137_;
		ValaDataType* _tmp138_;
		ValaTypeSymbol* _tmp139_;
		ValaTypeSymbol* _tmp140_;
		_tmp137_ = vala_variable_get_variable_type ((ValaVariable*) self);
		_tmp138_ = _tmp137_;
		_tmp139_ = vala_data_type_get_type_symbol (_tmp138_);
		_tmp140_ = _tmp139_;
		if (_tmp140_ != NULL) {
			ValaDataType* _tmp141_;
			ValaDataType* _tmp142_;
			ValaTypeSymbol* _tmp143_;
			ValaTypeSymbol* _tmp144_;
			ValaVersionAttribute* _tmp145_;
			ValaVersionAttribute* _tmp146_;
			ValaSourceReference* _tmp147_;
			ValaSourceReference* _tmp148_;
			_tmp141_ = vala_variable_get_variable_type ((ValaVariable*) self);
			_tmp142_ = _tmp141_;
			_tmp143_ = vala_data_type_get_type_symbol (_tmp142_);
			_tmp144_ = _tmp143_;
			_tmp145_ = vala_symbol_get_version ((ValaSymbol*) _tmp144_);
			_tmp146_ = _tmp145_;
			_tmp147_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp148_ = _tmp147_;
			vala_version_attribute_check (_tmp146_, context, _tmp148_);
		}
	}
	_tmp149_ = vala_variable_get_variable_type ((ValaVariable*) self);
	_tmp150_ = _tmp149_;
	variable_array_type = VALA_IS_ARRAY_TYPE (_tmp150_) ? ((ValaArrayType*) _tmp150_) : NULL;
	_tmp154_ = variable_array_type;
	if (_tmp154_ != NULL) {
		ValaArrayType* _tmp155_;
		gboolean _tmp156_;
		gboolean _tmp157_;
		_tmp155_ = variable_array_type;
		_tmp156_ = vala_array_type_get_inline_allocated (_tmp155_);
		_tmp157_ = _tmp156_;
		_tmp153_ = _tmp157_;
	} else {
		_tmp153_ = FALSE;
	}
	if (_tmp153_) {
		ValaExpression* _tmp158_;
		ValaExpression* _tmp159_;
		_tmp158_ = vala_variable_get_initializer ((ValaVariable*) self);
		_tmp159_ = _tmp158_;
		_tmp152_ = VALA_IS_ARRAY_CREATION_EXPRESSION (_tmp159_);
	} else {
		_tmp152_ = FALSE;
	}
	if (_tmp152_) {
		ValaExpression* _tmp160_;
		ValaExpression* _tmp161_;
		ValaInitializerList* _tmp162_;
		ValaInitializerList* _tmp163_;
		_tmp160_ = vala_variable_get_initializer ((ValaVariable*) self);
		_tmp161_ = _tmp160_;
		_tmp162_ = vala_array_creation_expression_get_initializer_list (G_TYPE_CHECK_INSTANCE_CAST (_tmp161_, VALA_TYPE_ARRAY_CREATION_EXPRESSION, ValaArrayCreationExpression));
		_tmp163_ = _tmp162_;
		_tmp151_ = _tmp163_ == NULL;
	} else {
		_tmp151_ = FALSE;
	}
	if (_tmp151_) {
		ValaSourceReference* _tmp164_;
		ValaSourceReference* _tmp165_;
		_tmp164_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp165_ = _tmp164_;
		vala_report_warning (_tmp165_, "Inline allocated arrays don't require an explicit instantiation");
		vala_variable_set_initializer ((ValaVariable*) self, NULL);
	}
	_tmp169_ = variable_array_type;
	if (_tmp169_ != NULL) {
		ValaArrayType* _tmp170_;
		gboolean _tmp171_;
		gboolean _tmp172_;
		_tmp170_ = variable_array_type;
		_tmp171_ = vala_array_type_get_inline_allocated (_tmp170_);
		_tmp172_ = _tmp171_;
		_tmp168_ = _tmp172_;
	} else {
		_tmp168_ = FALSE;
	}
	if (_tmp168_) {
		ValaArrayType* _tmp173_;
		ValaExpression* _tmp174_;
		ValaExpression* _tmp175_;
		_tmp173_ = variable_array_type;
		_tmp174_ = vala_array_type_get_length (_tmp173_);
		_tmp175_ = _tmp174_;
		_tmp167_ = _tmp175_ == NULL;
	} else {
		_tmp167_ = FALSE;
	}
	if (_tmp167_) {
		ValaExpression* _tmp176_;
		ValaExpression* _tmp177_;
		_tmp176_ = vala_variable_get_initializer ((ValaVariable*) self);
		_tmp177_ = _tmp176_;
		_tmp166_ = !VALA_IS_ARRAY_CREATION_EXPRESSION (_tmp177_);
	} else {
		_tmp166_ = FALSE;
	}
	if (_tmp166_) {
		ValaSourceReference* _tmp178_;
		ValaSourceReference* _tmp179_;
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		_tmp178_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp179_ = _tmp178_;
		vala_report_error (_tmp179_, "Inline allocated array requires either a given length or an initialize" \
"r");
	}
	_tmp181_ = vala_variable_get_initializer ((ValaVariable*) self);
	_tmp182_ = _tmp181_;
	if (_tmp182_ != NULL) {
		ValaExpression* _tmp183_;
		ValaExpression* _tmp184_;
		gboolean _tmp185_;
		gboolean _tmp186_;
		_tmp183_ = vala_variable_get_initializer ((ValaVariable*) self);
		_tmp184_ = _tmp183_;
		_tmp185_ = vala_code_node_get_error ((ValaCodeNode*) _tmp184_);
		_tmp186_ = _tmp185_;
		_tmp180_ = !_tmp186_;
	} else {
		_tmp180_ = FALSE;
	}
	if (_tmp180_) {
		ValaExpression* _tmp187_;
		ValaExpression* _tmp188_;
		ValaDataType* _tmp189_;
		ValaDataType* _tmp190_;
		ValaExpression* _tmp236_;
		ValaExpression* _tmp237_;
		ValaDataType* _tmp238_;
		ValaDataType* _tmp239_;
		ValaDataType* _tmp240_;
		ValaDataType* _tmp241_;
		gboolean _tmp281_ = FALSE;
		gboolean _tmp282_ = FALSE;
		gboolean _tmp283_ = FALSE;
		ValaArrayType* _tmp284_;
		gboolean _tmp298_ = FALSE;
		gboolean _tmp299_ = FALSE;
		ValaArrayType* _tmp300_;
		ValaExpression* _tmp310_;
		ValaExpression* _tmp311_;
		ValaDataType* _tmp312_;
		ValaDataType* _tmp313_;
		_tmp187_ = vala_variable_get_initializer ((ValaVariable*) self);
		_tmp188_ = _tmp187_;
		_tmp189_ = vala_expression_get_value_type (_tmp188_);
		_tmp190_ = _tmp189_;
		if (VALA_IS_METHOD_TYPE (_tmp190_)) {
			gboolean _tmp191_ = FALSE;
			ValaExpression* _tmp192_;
			ValaExpression* _tmp193_;
			ValaDataType* _tmp200_;
			ValaDataType* _tmp201_;
			_tmp192_ = vala_variable_get_initializer ((ValaVariable*) self);
			_tmp193_ = _tmp192_;
			if (!VALA_IS_MEMBER_ACCESS (_tmp193_)) {
				ValaExpression* _tmp194_;
				ValaExpression* _tmp195_;
				_tmp194_ = vala_variable_get_initializer ((ValaVariable*) self);
				_tmp195_ = _tmp194_;
				_tmp191_ = !VALA_IS_LAMBDA_EXPRESSION (_tmp195_);
			} else {
				_tmp191_ = FALSE;
			}
			if (_tmp191_) {
				ValaExpression* _tmp196_;
				ValaExpression* _tmp197_;
				ValaSourceReference* _tmp198_;
				ValaSourceReference* _tmp199_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp196_ = vala_variable_get_initializer ((ValaVariable*) self);
				_tmp197_ = _tmp196_;
				_tmp198_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp197_);
				_tmp199_ = _tmp198_;
				vala_report_error (_tmp199_, "expression type not allowed as initializer");
				result = FALSE;
				return result;
			}
			_tmp200_ = vala_variable_get_variable_type ((ValaVariable*) self);
			_tmp201_ = _tmp200_;
			if (VALA_IS_DELEGATE_TYPE (_tmp201_)) {
				ValaExpression* _tmp202_;
				ValaExpression* _tmp203_;
				ValaDataType* _tmp204_;
				ValaDataType* _tmp205_;
				ValaDataType* _tmp206_;
				ValaDataType* _tmp207_;
				_tmp202_ = vala_variable_get_initializer ((ValaVariable*) self);
				_tmp203_ = _tmp202_;
				_tmp204_ = vala_expression_get_value_type (_tmp203_);
				_tmp205_ = _tmp204_;
				_tmp206_ = vala_variable_get_variable_type ((ValaVariable*) self);
				_tmp207_ = _tmp206_;
				if (!vala_data_type_compatible (_tmp205_, _tmp207_)) {
					ValaMethod* m = NULL;
					ValaExpression* _tmp208_;
					ValaExpression* _tmp209_;
					ValaSymbol* _tmp210_;
					ValaSymbol* _tmp211_;
					ValaDelegate* cb = NULL;
					ValaDataType* _tmp212_;
					ValaDataType* _tmp213_;
					ValaDelegate* _tmp214_;
					ValaDelegate* _tmp215_;
					ValaSourceReference* _tmp216_;
					ValaSourceReference* _tmp217_;
					ValaMethod* _tmp218_;
					gchar* _tmp219_;
					gchar* _tmp220_;
					ValaDelegate* _tmp221_;
					gchar* _tmp222_;
					gchar* _tmp223_;
					_tmp208_ = vala_variable_get_initializer ((ValaVariable*) self);
					_tmp209_ = _tmp208_;
					_tmp210_ = vala_expression_get_symbol_reference (_tmp209_);
					_tmp211_ = _tmp210_;
					m = G_TYPE_CHECK_INSTANCE_CAST (_tmp211_, VALA_TYPE_METHOD, ValaMethod);
					_tmp212_ = vala_variable_get_variable_type ((ValaVariable*) self);
					_tmp213_ = _tmp212_;
					_tmp214_ = vala_delegate_type_get_delegate_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp213_, VALA_TYPE_DELEGATE_TYPE, ValaDelegateType));
					_tmp215_ = _tmp214_;
					cb = _tmp215_;
					vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
					_tmp216_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
					_tmp217_ = _tmp216_;
					_tmp218_ = m;
					_tmp219_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp218_);
					_tmp220_ = _tmp219_;
					_tmp221_ = cb;
					_tmp222_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp221_);
					_tmp223_ = _tmp222_;
					vala_report_error (_tmp217_, "Declaration of method `%s' is not compatible with delegate `%s'", _tmp220_, _tmp223_);
					_g_free0 (_tmp223_);
					_g_free0 (_tmp220_);
					result = FALSE;
					return result;
				}
			} else {
				ValaExpression* _tmp224_;
				ValaExpression* _tmp225_;
				ValaSourceReference* _tmp226_;
				ValaSourceReference* _tmp227_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp224_ = vala_variable_get_initializer ((ValaVariable*) self);
				_tmp225_ = _tmp224_;
				_tmp226_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp225_);
				_tmp227_ = _tmp226_;
				vala_report_error (_tmp227_, "expression type not allowed as initializer");
				result = FALSE;
				return result;
			}
		} else {
			ValaExpression* _tmp228_;
			ValaExpression* _tmp229_;
			ValaDataType* _tmp230_;
			ValaDataType* _tmp231_;
			_tmp228_ = vala_variable_get_initializer ((ValaVariable*) self);
			_tmp229_ = _tmp228_;
			_tmp230_ = vala_expression_get_value_type (_tmp229_);
			_tmp231_ = _tmp230_;
			if (_tmp231_ == NULL) {
				ValaExpression* _tmp232_;
				ValaExpression* _tmp233_;
				ValaSourceReference* _tmp234_;
				ValaSourceReference* _tmp235_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp232_ = vala_variable_get_initializer ((ValaVariable*) self);
				_tmp233_ = _tmp232_;
				_tmp234_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp233_);
				_tmp235_ = _tmp234_;
				vala_report_error (_tmp235_, "expression type not allowed as initializer");
				result = FALSE;
				return result;
			}
		}
		_tmp236_ = vala_variable_get_initializer ((ValaVariable*) self);
		_tmp237_ = _tmp236_;
		_tmp238_ = vala_expression_get_value_type (_tmp237_);
		_tmp239_ = _tmp238_;
		_tmp240_ = vala_variable_get_variable_type ((ValaVariable*) self);
		_tmp241_ = _tmp240_;
		if (!vala_data_type_compatible (_tmp239_, _tmp241_)) {
			ValaSourceReference* _tmp242_;
			ValaSourceReference* _tmp243_;
			ValaExpression* _tmp244_;
			ValaExpression* _tmp245_;
			ValaDataType* _tmp246_;
			ValaDataType* _tmp247_;
			gchar* _tmp248_;
			gchar* _tmp249_;
			ValaDataType* _tmp250_;
			ValaDataType* _tmp251_;
			gchar* _tmp252_;
			gchar* _tmp253_;
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			_tmp242_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp243_ = _tmp242_;
			_tmp244_ = vala_variable_get_initializer ((ValaVariable*) self);
			_tmp245_ = _tmp244_;
			_tmp246_ = vala_expression_get_value_type (_tmp245_);
			_tmp247_ = _tmp246_;
			_tmp248_ = vala_code_node_to_string ((ValaCodeNode*) _tmp247_);
			_tmp249_ = _tmp248_;
			_tmp250_ = vala_variable_get_variable_type ((ValaVariable*) self);
			_tmp251_ = _tmp250_;
			_tmp252_ = vala_code_node_to_string ((ValaCodeNode*) _tmp251_);
			_tmp253_ = _tmp252_;
			vala_report_error (_tmp243_, "Assignment: Cannot convert from `%s' to `%s'", _tmp249_, _tmp253_);
			_g_free0 (_tmp253_);
			_g_free0 (_tmp249_);
			result = FALSE;
			return result;
		} else {
			gboolean _tmp254_ = FALSE;
			gboolean _tmp255_ = FALSE;
			ValaDataType* _tmp256_;
			ValaDataType* _tmp257_;
			_tmp256_ = vala_variable_get_variable_type ((ValaVariable*) self);
			_tmp257_ = _tmp256_;
			if (VALA_IS_ENUM_VALUE_TYPE (_tmp257_)) {
				ValaExpression* _tmp258_;
				ValaExpression* _tmp259_;
				ValaDataType* _tmp260_;
				ValaDataType* _tmp261_;
				_tmp258_ = vala_variable_get_initializer ((ValaVariable*) self);
				_tmp259_ = _tmp258_;
				_tmp260_ = vala_expression_get_value_type (_tmp259_);
				_tmp261_ = _tmp260_;
				_tmp255_ = VALA_IS_INTEGER_TYPE (_tmp261_);
			} else {
				_tmp255_ = FALSE;
			}
			if (_tmp255_) {
				gboolean _tmp262_ = FALSE;
				ValaExpression* _tmp263_;
				ValaExpression* _tmp264_;
				_tmp263_ = vala_variable_get_initializer ((ValaVariable*) self);
				_tmp264_ = _tmp263_;
				if (!VALA_IS_INTEGER_LITERAL (_tmp264_)) {
					_tmp262_ = TRUE;
				} else {
					ValaExpression* _tmp265_;
					ValaExpression* _tmp266_;
					const gchar* _tmp267_;
					const gchar* _tmp268_;
					_tmp265_ = vala_variable_get_initializer ((ValaVariable*) self);
					_tmp266_ = _tmp265_;
					_tmp267_ = vala_integer_literal_get_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp266_, VALA_TYPE_INTEGER_LITERAL, ValaIntegerLiteral));
					_tmp268_ = _tmp267_;
					_tmp262_ = g_strcmp0 (_tmp268_, "0") != 0;
				}
				_tmp254_ = _tmp262_;
			} else {
				_tmp254_ = FALSE;
			}
			if (_tmp254_) {
				ValaSourceReference* _tmp269_;
				ValaSourceReference* _tmp270_;
				ValaExpression* _tmp271_;
				ValaExpression* _tmp272_;
				ValaDataType* _tmp273_;
				ValaDataType* _tmp274_;
				gchar* _tmp275_;
				gchar* _tmp276_;
				ValaDataType* _tmp277_;
				ValaDataType* _tmp278_;
				gchar* _tmp279_;
				gchar* _tmp280_;
				_tmp269_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp270_ = _tmp269_;
				_tmp271_ = vala_variable_get_initializer ((ValaVariable*) self);
				_tmp272_ = _tmp271_;
				_tmp273_ = vala_expression_get_value_type (_tmp272_);
				_tmp274_ = _tmp273_;
				_tmp275_ = vala_code_node_to_string ((ValaCodeNode*) _tmp274_);
				_tmp276_ = _tmp275_;
				_tmp277_ = vala_variable_get_variable_type ((ValaVariable*) self);
				_tmp278_ = _tmp277_;
				_tmp279_ = vala_code_node_to_string ((ValaCodeNode*) _tmp278_);
				_tmp280_ = _tmp279_;
				vala_report_notice (_tmp270_, "Assignment: Unsafe conversion from `%s' to `%s'", _tmp276_, _tmp280_);
				_g_free0 (_tmp280_);
				_g_free0 (_tmp276_);
			}
		}
		_tmp284_ = variable_array_type;
		if (_tmp284_ != NULL) {
			ValaArrayType* _tmp285_;
			gboolean _tmp286_;
			gboolean _tmp287_;
			_tmp285_ = variable_array_type;
			_tmp286_ = vala_array_type_get_inline_allocated (_tmp285_);
			_tmp287_ = _tmp286_;
			_tmp283_ = _tmp287_;
		} else {
			_tmp283_ = FALSE;
		}
		if (_tmp283_) {
			ValaArrayType* _tmp288_;
			gboolean _tmp289_;
			gboolean _tmp290_;
			_tmp288_ = variable_array_type;
			_tmp289_ = vala_array_type_get_fixed_length (_tmp288_);
			_tmp290_ = _tmp289_;
			_tmp282_ = !_tmp290_;
		} else {
			_tmp282_ = FALSE;
		}
		if (_tmp282_) {
			_tmp281_ = is_initializer_list;
		} else {
			_tmp281_ = FALSE;
		}
		if (_tmp281_) {
			ValaArrayType* _tmp291_;
			gchar* _tmp292_;
			gchar* _tmp293_;
			ValaIntegerLiteral* _tmp294_;
			ValaIntegerLiteral* _tmp295_;
			ValaArrayType* _tmp296_;
			ValaArrayType* _tmp297_;
			_tmp291_ = variable_array_type;
			_tmp292_ = g_strdup_printf ("%i", initializer_size);
			_tmp293_ = _tmp292_;
			_tmp294_ = vala_integer_literal_new (_tmp293_, NULL);
			_tmp295_ = _tmp294_;
			vala_array_type_set_length (_tmp291_, (ValaExpression*) _tmp295_);
			_vala_code_node_unref0 (_tmp295_);
			_g_free0 (_tmp293_);
			_tmp296_ = variable_array_type;
			vala_array_type_set_fixed_length (_tmp296_, TRUE);
			_tmp297_ = variable_array_type;
			vala_data_type_set_nullable ((ValaDataType*) _tmp297_, FALSE);
		}
		_tmp300_ = variable_array_type;
		if (_tmp300_ != NULL) {
			ValaArrayType* _tmp301_;
			gboolean _tmp302_;
			gboolean _tmp303_;
			_tmp301_ = variable_array_type;
			_tmp302_ = vala_array_type_get_inline_allocated (_tmp301_);
			_tmp303_ = _tmp302_;
			_tmp299_ = _tmp303_;
		} else {
			_tmp299_ = FALSE;
		}
		if (_tmp299_) {
			ValaExpression* _tmp304_;
			ValaExpression* _tmp305_;
			ValaDataType* _tmp306_;
			ValaDataType* _tmp307_;
			_tmp304_ = vala_variable_get_initializer ((ValaVariable*) self);
			_tmp305_ = _tmp304_;
			_tmp306_ = vala_expression_get_value_type (_tmp305_);
			_tmp307_ = _tmp306_;
			_tmp298_ = VALA_IS_ARRAY_TYPE (_tmp307_) == FALSE;
		} else {
			_tmp298_ = FALSE;
		}
		if (_tmp298_) {
			ValaSourceReference* _tmp308_;
			ValaSourceReference* _tmp309_;
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			_tmp308_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp309_ = _tmp308_;
			vala_report_error (_tmp309_, "only arrays are allowed as initializer for arrays with fixed length");
			result = FALSE;
			return result;
		}
		_tmp310_ = vala_variable_get_initializer ((ValaVariable*) self);
		_tmp311_ = _tmp310_;
		_tmp312_ = vala_expression_get_value_type (_tmp311_);
		_tmp313_ = _tmp312_;
		if (vala_data_type_is_disposable (_tmp313_)) {
			gboolean _tmp314_ = FALSE;
			ValaDataType* _tmp315_;
			ValaDataType* _tmp316_;
			_tmp315_ = vala_variable_get_variable_type ((ValaVariable*) self);
			_tmp316_ = _tmp315_;
			if (!VALA_IS_POINTER_TYPE (_tmp316_)) {
				ValaDataType* _tmp317_;
				ValaDataType* _tmp318_;
				gboolean _tmp319_;
				gboolean _tmp320_;
				_tmp317_ = vala_variable_get_variable_type ((ValaVariable*) self);
				_tmp318_ = _tmp317_;
				_tmp319_ = vala_data_type_get_value_owned (_tmp318_);
				_tmp320_ = _tmp319_;
				_tmp314_ = !_tmp320_;
			} else {
				_tmp314_ = FALSE;
			}
			if (_tmp314_) {
				ValaSourceReference* _tmp321_;
				ValaSourceReference* _tmp322_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp321_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp322_ = _tmp321_;
				vala_report_error (_tmp322_, "Invalid assignment from owned expression to unowned variable");
				result = FALSE;
				return result;
			}
		}
	}
	_tmp323_ = vala_code_context_get_analyzer (context);
	_tmp324_ = _tmp323_;
	_tmp325_ = vala_semantic_analyzer_get_current_symbol (_tmp324_);
	_tmp326_ = _tmp325_;
	block = VALA_IS_BLOCK (_tmp326_) ? ((ValaBlock*) _tmp326_) : NULL;
	_tmp327_ = block;
	if (_tmp327_ != NULL) {
		ValaBlock* _tmp328_;
		_tmp328_ = block;
		vala_block_add_local_variable (_tmp328_, self);
	}
	vala_symbol_set_active ((ValaSymbol*) self, TRUE);
	_tmp329_ = vala_code_node_get_error ((ValaCodeNode*) self);
	_tmp330_ = _tmp329_;
	result = !_tmp330_;
	return result;
}

static void
vala_local_variable_class_init (ValaLocalVariableClass * klass,
                                gpointer klass_data)
{
	vala_local_variable_parent_class = g_type_class_peek_parent (klass);
	((ValaCodeNodeClass *) klass)->finalize = vala_local_variable_finalize;
	g_type_class_adjust_private_offset (klass, &ValaLocalVariable_private_offset);
	((ValaCodeNodeClass *) klass)->accept = (void (*) (ValaCodeNode*, ValaCodeVisitor*)) vala_local_variable_real_accept;
	((ValaCodeNodeClass *) klass)->accept_children = (void (*) (ValaCodeNode*, ValaCodeVisitor*)) vala_local_variable_real_accept_children;
	((ValaCodeNodeClass *) klass)->replace_expression = (void (*) (ValaCodeNode*, ValaExpression*, ValaExpression*)) vala_local_variable_real_replace_expression;
	((ValaCodeNodeClass *) klass)->replace_type = (void (*) (ValaCodeNode*, ValaDataType*, ValaDataType*)) vala_local_variable_real_replace_type;
	((ValaCodeNodeClass *) klass)->check = (gboolean (*) (ValaCodeNode*, ValaCodeContext*)) vala_local_variable_real_check;
}

static void
vala_local_variable_instance_init (ValaLocalVariable * self,
                                   gpointer klass)
{
	self->priv = vala_local_variable_get_instance_private (self);
}

static void
vala_local_variable_finalize (ValaCodeNode * obj)
{
	ValaLocalVariable * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_TYPE_LOCAL_VARIABLE, ValaLocalVariable);
	VALA_CODE_NODE_CLASS (vala_local_variable_parent_class)->finalize (obj);
}

/**
 * Represents a local variable declaration in the source code.
 */
static GType
vala_local_variable_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ValaLocalVariableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_local_variable_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaLocalVariable), 0, (GInstanceInitFunc) vala_local_variable_instance_init, NULL };
	GType vala_local_variable_type_id;
	vala_local_variable_type_id = g_type_register_static (VALA_TYPE_VARIABLE, "ValaLocalVariable", &g_define_type_info, 0);
	ValaLocalVariable_private_offset = g_type_add_instance_private (vala_local_variable_type_id, sizeof (ValaLocalVariablePrivate));
	return vala_local_variable_type_id;
}

GType
vala_local_variable_get_type (void)
{
	static volatile gsize vala_local_variable_type_id__once = 0;
	if (g_once_init_enter (&vala_local_variable_type_id__once)) {
		GType vala_local_variable_type_id;
		vala_local_variable_type_id = vala_local_variable_get_type_once ();
		g_once_init_leave (&vala_local_variable_type_id__once, vala_local_variable_type_id);
	}
	return vala_local_variable_type_id__once;
}

